using System;
using System.Collections.Generic;
using System.Text;

namespace MaxDeRobot.Resources
{
    class Acties
    {
        private string[] atl = { "Lopen", "Praten", "Arm/Hoofd", "Tekening", 
            "Geluid", "Voelknop", "Iets zien" };
        private string at; // actie type

        // acties
        private string[] atlbs; // actie parameter labels
        private string[] actieLabelsLopen = new string[] { "Richting", "Stappen", "Snelheid" };
        private string[] actieLabelsPraten = new string[] { "Tekst", "Aantal keer" };
        private string[] actieLabelsArmBewegen = new string[] { "Tijdsduur", "Snelheid" };
        private string[] actieLabelsTekeningTonen = new string[] { "Afbeelding", "Tijdsduur" };

        // sensoren 
        private string[] sensorLabelsGeluid = new string[] { "Activeer op DB: " };
        private string[] sensorLabelsVoelknop = new string[] { "Aantal keer indrukken: " };
        private string[] sensorLabelsIetsZien = new string[] { "Detectie beweging afstand: " };

        // Begin & Einde
        private string[] LabelsBegin = new string[] { };
        private string[] LabelsEinde = new string[] { };

        // Als..Dan
        private string[] LabelsAlsDan = new string[] { };

        private string[] LabelsLeeg = new string[] { };

        private string[] atprmts; // actie parameter waarden

        /*   //acties
        public Acties(int actieNumber)
        {
            string[] actieLijst = actieTypeLijst;
            actieType = actieLijst[actieNumber];

            switch (actieNumber)
            {
                case 0: // Lopen
                {
                    actieLabels = actieLabelsLopen;
                    break;
                }
                case 1: // Praten
                {
                    actieLabels = actieLabelsPraten;
                    break;
                }
                case 2: // Arm/Hoofd
                {
                    actieLabels = actieLabelsArmBewegen;
                    break;
                }
                case 3: // Tekening
                {
                    actieLabels = actieLabelsTekeningTonen;
                    break;
                }
                case 4: // Geluid
                {
                    actieLabels = sensorLabelsGeluid;
                    break;
                }
                case 5: // Voelknop
                {
                    actieLabels = sensorLabelsVoelknop;
                    break;
                }
                case 6: // Iets zien
                {
                    actieLabels = sensorLabelsIetsZien;
                    break;
                }
                case 7: // Begin
                {
                    actieLabels = LabelsBegin;
                    break;
                }
                case 8: // Einde
                {
                    actieLabels = LabelsEinde;
                    break;
                }
                default:
                {
                    actieType = "Geen matchende actieType";
                    break;
                }
            }
        }

         */

        public Acties(string typeActie, string[] parameters)
        {
            actieParameters = parameters;
            switch (typeActie)
            {
                case "Lopen":
                    {
                        actieType = "Lopen";
                        actieLabels = actieLabelsLopen;
                        break;
                    }
                case "Praten":
                    {
                        actieType = "Praten";
                        actieLabels = actieLabelsPraten;
                        break;
                    }
                case "Arm/Hoofd":
                    {
                        actieType = "Arm/Hoofd";
                        actieLabels = actieLabelsArmBewegen;
                        break;
                    }
                case "Tekening":
                    {
                        actieType = "Tekening";
                        actieLabels = actieLabelsTekeningTonen;
                        break;
                    }
                case "Geluid":
                    {
                        actieType = "Geluid";
                        actieLabels = sensorLabelsGeluid;
                        break;
                    }
                case "Voelknop":
                    {
                        actieType = "Voelknop";
                        actieLabels = sensorLabelsVoelknop;
                        break;
                    }
                case "Iets zien":
                    {
                        actieType = "Iets zien";
                        actieLabels = sensorLabelsIetsZien;
                        break;
                    }
                case "Begin":
                    {
                        actieType = "Begin";
                        actieLabels = LabelsBegin;
                        break;
                    }
                case "Einde":
                    {
                        actieType = "Einde";
                        actieLabels = LabelsEinde;
                        break;
                    }
                case "Als..Dan":
                    {
                        actieType = "Als..Dan";
                        actieLabels = LabelsAlsDan;
                        break;
                    }
                default:
                    {
                        actieType = "Geen matchende actieType";
                        actieLabels = LabelsLeeg;
                        break;
                    }
            }
        }

        public Acties(string str)
        {
            string typeActie = "";
            if (!(String.Equals(str, "Begin;") || String.Equals(str, "Einde;")))
                typeActie = str.Substring(0, str.IndexOf('('));
            else
                typeActie = str.Substring(0, str.IndexOf(';'));

            actieParameters = transformParameters(str);

            switch (typeActie)
            {
                case "Lopen":
                    {
                        actieType = "Lopen";
                        actieLabels = actieLabelsLopen;
                        break;
                    }
                case "Praten":
                    {
                        actieType = "Praten";
                        actieLabels = actieLabelsPraten;
                        break;
                    }
                case "Arm/Hoofd":
                    {
                        actieType = "Arm/Hoofd";
                        actieLabels = actieLabelsArmBewegen;
                        break;
                    }
                case "Tekening":
                    {
                        actieType = "Tekening";
                        actieLabels = actieLabelsTekeningTonen;
                        break;
                    }
                case "Geluid":
                    {
                        actieType = "Geluid";
                        actieLabels = sensorLabelsGeluid;
                        break;
                    }
                case "Voelknop":
                    {
                        actieType = "Voelknop";
                        actieLabels = sensorLabelsVoelknop;
                        break;
                    }
                case "Iets zien":
                    {
                        actieType = "Iets zien";
                        actieLabels = sensorLabelsIetsZien;
                        break;
                    }
                case "Begin":
                    {
                        actieType = "Begin";
                        actieLabels = LabelsBegin;
                        break;
                    }
                case "Einde":
                    {
                        actieType = "Einde";
                        actieLabels = LabelsEinde;
                        break;
                    }
                case "Als..Dan":
                    {
                        actieType = "Als..Dan";
                        actieLabels = LabelsAlsDan;
                        break;
                    }
                default:
                    {
                        actieType = "Geen matchende actieType. " + actieType;
                        actieLabels = LabelsLeeg;
                        break;
                    }
            }
        }

        public string[] actieLabels
        {
            get
            {
                return atlbs;
            }
            set
            {
                atlbs = value;
            }
        }

        public string actieType
        {
            get
            {
                return at;
            }
            set
            {
                at = value;
            }
        }

        public string[] actieTypeLijst
        {
            get
            {
                return atl;
            }
            set
            {
                atl = value;
            }
        }

        public string[] actieParameters
        {
            get
            {
                return atprmts;
            }
            set
            {
                atprmts = value;
            }
        }

        public string[] transformParameters(string str)
        {
            string[] parameters;
            string parameter;

            int endOfActionWord = str.IndexOf('(');
            str = str.Substring(endOfActionWord + 1, str.Length - (endOfActionWord + 1));
            string[] segments = str.Split(',');
            parameters = new string[segments.Length];
            for (int i = 0; i < segments.Length; i++)
            {
                parameter = segments[i];

                if (i + 1 == segments.Length)
                    parameter = (parameter.Substring(0, parameter.Length - 2)).Trim();

                parameters[i] = parameter.Trim();
            }

            return parameters;
        }

        public string toString()
        {
            string parameterText = "";
            string[] parameters = actieParameters;

            int parametersAmount = (parameters).Length;

            for (int i = 0; i < parametersAmount; i++)
            {
                parameterText += parameters[i];
                if (i + 1 < parametersAmount)
                    parameterText += ", ";
            }

            if (!(String.Equals(actieType, "Begin") || String.Equals(actieType, "Einde")))
                return actieType + "(" + parameterText + ");";
            else
                return actieType + ";";
        }

        /* //voor debug 
        public string toPseudoCode()
        {
            string pseudoCode = "";
            string[] parameters = actieParameters;

            switch (actieType)
            {
                case "Lopen":
                {
                    string richting = parameters[0];

                    if (parameters[0].Equals("links") || parameters[0].Equals("rechts"))
                        richting = "naar " + parameters[0];

                    pseudoCode = "Max loopt " + richting + " en zet " + parameters[1] + 
                                    " stappen op snelheid " + parameters[2] + "%.";
                    return pseudoCode;
                }
                case "Praten":
                {
                    string zin = "niks.";
                    if (String.Equals(parameters[0], "hallo"))
                        zin = "hallo ik ben Max.";
                    else
                        zin = parameters[0];
                    pseudoCode = "Max zegt " + zin;
                    return pseudoCode;
                }
                case "Arm/Hoofd":
                {
                    pseudoCode = "Max beweegt zijn hoofd en armen voor " + parameters[0] + " seconden op " 
                        + parameters[1] + "% snelheid.";
                    return pseudoCode;
                }
                case "Tekening":
                {
                    pseudoCode = "Max toont het plaatje " + parameters[1] + " op zijn borst voor " 
                        + parameters[0] +" seconden.";
                    return pseudoCode;
                }
                case "Geluid":
                {
                    pseudoCode = "Max reageert op geluid van " + parameters[0] + " db.";
                    return pseudoCode;
                }
                case "Voelknop":
                {
                    pseudoCode = "Max reageert op " + parameters[0] + " keer drukken.";
                    return pseudoCode;
                }
                case "Iets zien":
                {
                    pseudoCode = "Max reageert op beweging van " + parameters[0] + " cm afstand.";
                    return pseudoCode;
                }
                case "Begin":
                {
                    pseudoCode = "Max wordt wakker om te beginnen.";
                    return pseudoCode;
                }
                case "Einde":
                {
                    pseudoCode = "Max wordt wakker om te beginnen.";
                    return pseudoCode;
                }
                default:
                {
                    pseudoCode = "Max begrijpt er niks meer van.";
                    return pseudoCode;
                }
            }
        }
         * */

        private string[] getSensor(string str)
        {
            string[] actieNaam = new string[1];

            int beginOfActionWord = str.IndexOf('(');
            int endOfActionWord = str.IndexOf(')');
            actieNaam[0] = str;//.Substring(beginOfActionWord + 1, endOfActionWord - beginOfActionWord);

            return actieNaam;
        }
    }
}
