using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MaxDeRobot.Resources;
using System.Threading;

namespace MaxDeRobot
{
    public partial class mainForm : Form
    {
        public const int maxRijen = 20;
        public const int maxKolommen= 10;
        public const int maxDiepte = 2;
        string[,,] blokcodeArray = new string[maxRijen, maxKolommen, maxDiepte];
        int globalBcArrayPosition = 0; //Bc = (blokcode) het eerste deel van de blokcode array, dus blokcodeArray[**dit**][], nodig voor oa. blokcodescherm up/down navigatie 1 t/m 20
        int globalEsArrayPosition = 1; //Es = (eigenschappen) het tweede deel van de blokcode array, dus blokcodeArray[][**dit**], nodig voor oa. eigenschappenscherm up/down navigatie 1 t/m 5. Geinitializeerd op 1 omdat op 0 de naam is en vanaf 1 de eigenschappen beginnen
        int globalHulpVoorRijPositie=0; //nodig voor tijdelijk onthouden van welke rij actief is in het eigenschappenscherm in combinatie met globalEsArrayPosition
        int globalNewButtonTeller = 0; //nodig voor unieke button namen (button1, button2, etc.)
        int globalNewPictureBoxTeller = 0;
        int globalHuidigLesNummer =0;
        private Point mouseOffset;
        private Point test; //moet nog gerenamed worden is wel in gebruik!
        private Point currentPosButton1;
        private bool isMouseDown = false;
        private bool changeSemafoor = false;
        private bool eindeIsPlaced = false;
        private bool beginIsPlaced = false;
        int currentPosition = 0;
        int highestPosition = 0;
        Transformer tf; // ** our sweet finite state ultra simple compiler. To stay in Robotic Atmposhere it is named Transformer** 

        /* to do
         to do: change most variable names to shorter names
         to do: provide pre and post condition for every function
         to do: user interface modularity
         to do: provide drop down waardeboxen in ES scherm
         to do: filters weghalen
         */
       
        public mainForm()
        {
            InitializeComponent();
                     
            //initialize bc_array met ""
            for (int i=0; i < maxRijen; i++)
            {
                for (int j=0; j < maxKolommen; j++)
                {
                    for (int h = 0; h < maxDiepte; h++)
                    {
                        blokcodeArray[i, j, h] = "";
                    }
                }
            }

          

            //initialize tellerbox 
            blokcodeArray[0, 0, 0] = "eof";

            //initialize level
            setLes(1); 

            vulBcBoxen();

            
      

        }

        #region alle Mouse, Button, Menu Events            //probeer de events zo leeg mogelijk te houden en de intelligentie in een functie te stoppen

        #region alle Mouse Events

        private void dragButton_MouseDown(object sender, MouseEventArgs e)
        {
            int xOffset;
            int yOffset;
            int x;
            int y;
            changeSemafoor = false;

            //unboxing
            Button currentButton = (Button)sender;

            //deze point wordt gebruikt als het object niet gedropt kan worden. Dan gaat het object weer terug naar oorspronkelijke plaats
            currentPosButton1 = new Point(currentButton.Location.X, currentButton.Location.Y);

            Point currentMousePos = Control.MousePosition;

            if (e.Button == MouseButtons.Left)
            {
                xOffset = -(currentMousePos.X - currentButton.Location.X);
                yOffset = -(currentMousePos.Y - currentButton.Location.Y);

                x = (currentMousePos.X - e.X - currentButton.Location.X);
                y = (currentMousePos.Y - e.Y - currentButton.Location.Y);

                mouseOffset = new Point(xOffset, yOffset);
                test = new Point(x, y);


                //check of geklikt is op een button die gedragt mag worden of juist op een blokcode button.Alle drag buttons staan op locatie kleiner dan locatie van dropBoxen (die zijn nl. vanaf 299)
                if (currentButton.Location.X < bcDropBox1.Location.X)
                {
                    isMouseDown = true;
                }
                else
                {
                    int bcArrayPos = 0;
                    bcArrayPos = checkButtonLocatie(currentPosButton1);

                    if (currentButton.Text == "Als..Dan")
                    {
                        if (blokcodeArray[bcArrayPos, 1, 0] == "Ja")
                        {
                            tekenEigenschapPlaatje(currentButton);
                            vulEsBoxen(bcArrayPos, globalEsArrayPosition);
                        }
                        else //nee
                        {
                            tekenEigenschapPlaatje(currentButton);
                            vulEsBoxen(bcArrayPos, globalEsArrayPosition);
                        }
                    }
                    else
                    {
                        //is nodg om elke x weer op positie 1 te beginnen in het eigenschappen scherm (hij slaat dus de naam  (positie 0) over. Omdat bij een vorige selectie eigenschap4 gekozen kan zijn neemt hij ook dit getal mee en dat wekt de illusie dat eigenschap 1 verdwenen is)
                        globalEsArrayPosition = 1;

                        bcArrayPos = checkButtonLocatie(currentPosButton1);

                        //zet plaatje van betreffende actie/sensor/overig op imagebox ******nog doen ^^, wordt maybe een form ipv imagebox *******
                        tekenEigenschapPlaatje(currentButton);

                        //Gebruik de tellerbox om bij te houden welke rij box 1 is, en hoewel globalEs positie niet nodig is om mee tegeven bij deze event wordt vanwege de consistentie dit wel gedaan
                        vulEsBoxen(bcArrayPos, globalEsArrayPosition);
                    }
                }
            }
            changeSemafoor = true;
        } // needs to be split in mousedown event for dragButton and mousedown event for Button inside of blokcode box  Steven

        private void dragButton_MouseMove(object sender, MouseEventArgs e)
        {
            //unboxing
            Button currentButton = (Button)sender;

            if (isMouseDown)
            {
                Point currentMousePos = Control.MousePosition;
                currentMousePos.Offset(mouseOffset.X, mouseOffset.Y);
                currentButton.Location = currentMousePos;
                currentButton.BringToFront();
            }
        } // needs to be split in mousemove event for dragButton and mousemove event for Button inside of blokcode box  Steven

        private void dragButton_MouseUp(object sender, MouseEventArgs e)
        {
            //unboxing
            Button currentButton = (Button)sender;

            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
                checkDropLocatie(currentButton);
            }
        } // needs to be split in mouseup event for dragButton and mouseup event for Button inside of blokcode box  Steven

        private void bcButton_Click(object sender, MouseEventArgs e)
        {
        } // splitted mouse event code must be placed inside this method   Steven

        #endregion

        #region Alle Menu events // most menu functions needs to implemented first before optimizing

        private void nieuwToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            nieuwMaxFile(); //opent nieuw .max bestand  (Maxnieuw.max) en maakt bcarray helemaal leeg
        }

        private void openToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            openFileDialog1.Title = "Zoek en open jouw Max programma en klik op OPENEN";
            openFileDialog1.Filter = "Max Programma's|*.max";
            openFileDialog1.DefaultExt = "max";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName == "")
                return;

            string CurrentFile = openFileDialog1.FileName.ToString();

            FileController fc = new FileController(CurrentFile);

            for (int i = 0; i < fc.rowCount; i++)
            {
                string type = fc.ReadFileLine(i);

                if (!String.Equals(type, ""))
                {
                    Acties actie = new Acties(type);

                    blokcodeArray[currentPosition, 0, 0] = actie.actieType;
                    int lastParameter = 0;

                    for (int j = 0; j < actie.actieParameters.Length; j++)
                    {
                        blokcodeArray[currentPosition, j + 1, 0] = actie.actieParameters[j];
                        lastParameter = j + 1;
                    }

                    if (lastParameter > 0)
                        blokcodeArray[currentPosition, lastParameter + 1, 0] = "eol";
                    else
                        blokcodeArray[currentPosition, 1, 0] = "eol";

                    currentPosition += 1;
                    highestPosition += 1;
                }
            }

            blokcodeArray[currentPosition, 0, 0] = "eof";
            toPseudoBoxCode();

            vulBcBoxen();
        }

        private void opslaanToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            /*            saveFileDialog1.Title = "Zoek en open jouw Max programma en klik op OPSLAAN";
            saveFileDialog1.Filter = "Max Programma's|*.max";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.OverwritePrompt = true;

            string CurrentFile = saveFileDialog1.FileName.ToString();
*/
            FileStream maxFile = new FileStream("Maxnieuw.max", FileMode.Create, FileAccess.ReadWrite);
            StreamWriter maxfileStream = new StreamWriter(maxFile);

            int i = 0;
            string regel = "";

            while (!String.Equals(blokcodeArray[i, 0, 0], "eof"))
            {
                Acties actie = new Acties(blokcodeArray[i, 0, 0], getParameterArray(i));
                regel = actie.toString();
                maxfileStream.WriteLine(regel);
                i++;
            }

            maxfileStream.Close();
        }

        private void maxDeRobotAfsluitenToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void beginnerNiveauToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //niveau is beginner, dus alles is kaal. visible zijn acties scherm, blokcode scherm zonder knoppen, bouw knop. Begin en Einde zijn al voor geprogrammeerd.

            beginnerNiveauToolStripMenuItem.Checked = true;
            gevorderdeNiveauToolStripMenuItem.Checked = false;
            expertNiveauToolStripMenuItem.Checked = false;

            setLevel("beginner");
        }

        private void les1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(1);
        }

        private void les2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(2);
        }

        private void les3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(3);
        }

        private void les4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(4);
        }

        private void les5ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(5);
        }

        private void les6ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(6);
        }

        private void les7ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(7);
        }

        private void les8ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(8);
        }

        private void les9ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(9);
        }

        private void les10ToolStripMenuItem_Click(object sender, EventArgs e)
        {
           // setLes(10);
        }

        private void les11ToolStripMenuItem_Click(object sender, EventArgs e)
        {
          //  setLes(11);
        }

        private void les12ToolStripMenuItem_Click(object sender, EventArgs e)
        {
           // setLes(12);
        }

        private void les13ToolStripMenuItem_Click(object sender, EventArgs e)
        {
          //  setLes(13);
        }

        private void les14ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLes(14);
        }

        private void gevorderdeNiveauToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //niveau is gevorderde. visible zijn acties en sensors, begin en einde. blokeigenschappen scherm visible. 

            beginnerNiveauToolStripMenuItem.Checked = false;
            gevorderdeNiveauToolStripMenuItem.Checked = true;
            expertNiveauToolStripMenuItem.Checked = false;

            setLevel("gevorderde");
        }

        private void expertNiveauToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //niveau is expert. visible zijn blokcode scherm knoppen, als..dan. en pseudobox

            beginnerNiveauToolStripMenuItem.Checked = false;
            gevorderdeNiveauToolStripMenuItem.Checked = false;
            expertNiveauToolStripMenuItem.Checked = true;

            setLevel("expert");
        }

        #endregion //Menu events

        #region Alle regelDeleteButton events van Blokcode scherm (code optimized)

        private void regel1DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition);
            checkEofOmhoog();
            vulBcBoxen();
        }

        private void regel2DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition+1);
            checkEofOmhoog();
            vulBcBoxen();
        }

        private void regel3DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition+2);
            checkEofOmhoog();
            vulBcBoxen();
        }

        private void regel4DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition+3);
            checkEofOmhoog();
            vulBcBoxen();
        }

        private void regel5DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition+4);
            checkEofOmhoog();
            vulBcBoxen();
        }

        private void regel6DeleteButton_Click(object sender, EventArgs e)
        {
            esLeeg(globalBcArrayPosition+5);
            checkEofOmhoog();
            vulBcBoxen();
        }

        #endregion //einde region DeleteButton events van Blokcode scherm

        #region Alle regelUpButton events van Blokcode scherm (code optimized)

        private void regel1UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition);
        }

        private void regel2UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition + 1);
        }

        private void regel3UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition + 2);
        }

        private void regel4UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition + 3);
        }

        private void regel5UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition + 4);
        }

        private void regel6UpButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmhoog(globalBcArrayPosition + 5);
        }

        #endregion //regelUpButton events van Blokcode scherm

        #region Alle regelDownButton events van Blokcode scherm (code optimized)

        private void regel1DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition);
        }
   
        private void regel2DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition+1);
        }

        private void regel3DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition + 2);
        }

        private void regel4DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition + 3);
        }

        private void regel5DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition + 4);
        }

        private void regel6DownButton_Click(object sender, EventArgs e)
        {
            arrayregelOmdraaienOmlaag(globalBcArrayPosition + 5);
        }

        #endregion //regelDownbutton events van Blokcode scherm

        #region Alle Up/Down navigatie button events van Blokcode scherm  // not working properly with als..dan

        private void bcUpButton_Click(object sender, EventArgs e)
        {
            if ((globalBcArrayPosition - 1) > -1)
                globalBcArrayPosition = globalBcArrayPosition - 1;

            vulBcBoxen();
        }

        private void bcDownButton_Click(object sender, EventArgs e)
        {
            if ((globalBcArrayPosition + 6) < maxRijen)
                globalBcArrayPosition = globalBcArrayPosition + 1;

            vulBcBoxen();
        }

        #endregion Up/Down navigatie button events van Blokcode scherm 

        #region Alle Up/Down navigatie button events van Eigenschappen scherm (code optimized)

        private void esUpButton_Click(object sender, EventArgs e)
        {

            if ((globalEsArrayPosition - 1) > 0)
            {
                globalEsArrayPosition = globalEsArrayPosition - 1;
                vulEsBoxen(globalHulpVoorRijPositie, globalEsArrayPosition);
            }
        }

        private void esDownButton_Click(object sender, EventArgs e)
        {
            if (((globalEsArrayPosition + 2) < maxKolommen) && !(String.Equals(blokcodeArray[globalHulpVoorRijPositie, globalEsArrayPosition + 2, 0], "eol")))
            {
                globalEsArrayPosition = globalEsArrayPosition + 1;
                vulEsBoxen(globalHulpVoorRijPositie, globalEsArrayPosition);
            }
        }

        #endregion Up/Down navigatie buttons van Eigenschappen scherm

        private void lesVolgendeButton_Click(object sender, EventArgs e)
        {
            if (globalHuidigLesNummer < 9)
            {
                setLes(globalHuidigLesNummer + 1);
            }
        }

        private void lesVorigeButton_Click(object sender, EventArgs e)
        {
            if (globalHuidigLesNummer > 1)
            {
                setLes(globalHuidigLesNummer - 1);
            }
        }

        private void bouwButton_Click(object sender, EventArgs e)
        {
            tf.transform();
        } //code optimized



        #endregion 

        #region alle Functies

        #region Inputscherm 
       
        private void createNewDragButton(string soortButton)
        {
            Button newButton = new Button();
            globalNewButtonTeller += 1;

            newButton.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
            newButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            newButton.TabIndex = 24 + globalNewButtonTeller;
            newButton.UseVisualStyleBackColor = false;
            newButton.Size = new System.Drawing.Size(114, 24);

            newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
            newButton.MouseMove += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseMove);
            newButton.MouseUp += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseUp);

            switch (soortButton)
            {
                case "Lopen":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(232)))), ((int)(((byte)(250)))), ((int)(((byte)(239)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 134);
                        newButton.Name = "lopenButton" + globalNewButtonTeller;
                        newButton.Text = "Lopen";
                    }
                    break;

                case "Praten":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(232)))), ((int)(((byte)(250)))), ((int)(((byte)(239)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 162);
                        newButton.Name = "pratenButton" + globalNewButtonTeller;
                        newButton.Text = "Praten";
                    }
                    break;

                case "Arm/Hoofd":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(232)))), ((int)(((byte)(250)))), ((int)(((byte)(239)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 190);
                        newButton.Name = "armHoofdButton" + globalNewButtonTeller;
                        newButton.Text = "Arm/Hoofd";
                    }
                    break;

                case "Tekening":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(232)))), ((int)(((byte)(250)))), ((int)(((byte)(239)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 218);
                        newButton.Name = "pratenButton" + globalNewButtonTeller;
                        newButton.Text = "Tekening";
                    }
                    break;

                case "Geluid":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(233)))), ((int)(((byte)(245)))), ((int)(((byte)(250)))));
                        newButton.ImageIndex = 1;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 286);
                        newButton.Name = "geluidButton" + globalNewButtonTeller;
                        newButton.Text = "Geluid";
                    }
                    break;

                case "Voelknop":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(233)))), ((int)(((byte)(245)))), ((int)(((byte)(250)))));
                        newButton.ImageIndex = 1;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 313);
                        newButton.Name = "voelknopButton" + globalNewButtonTeller;
                        newButton.Text = "Voelknop";
                    }
                    break;

                case "Iets zien":
                    {
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(233)))), ((int)(((byte)(245)))), ((int)(((byte)(250)))));
                        newButton.ImageIndex = 1;
                        newButton.ImageList = this.imageList2;
                        newButton.Location = new System.Drawing.Point(79, 341);
                        newButton.Name = "ietszienButon" + globalNewButtonTeller;
                        newButton.Text = "Iets zien";
                    }
                    break;

                case "Begin":
                    {
                        newButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                        newButton.Size = new System.Drawing.Size(72, 21);
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(249)))), ((int)(((byte)(250)))), ((int)(((byte)(232)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList1;
                        newButton.Location = new System.Drawing.Point(55, 429);
                        newButton.Name = "beginButon" + globalNewButtonTeller;
                        newButton.Text = "Begin";
                    }
                    break;

                case "Einde":
                    {
                        newButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                        newButton.Size = new System.Drawing.Size(72, 21);
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(249)))), ((int)(((byte)(250)))), ((int)(((byte)(232)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList1;
                        newButton.Location = new System.Drawing.Point(55, 452);
                        newButton.Name = "eindeButon" + globalNewButtonTeller;
                        newButton.Text = "Einde";
                    }
                    break;

                case "Als..Dan":
                    {
                        newButton.Size = new System.Drawing.Size(69, 44);
                        newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(249)))), ((int)(((byte)(250)))), ((int)(((byte)(232)))));
                        newButton.ImageIndex = 0;
                        newButton.ImageList = this.imageList3;
                        newButton.Location = new System.Drawing.Point(129, 429);
                        newButton.Name = "alsdanButon" + globalNewButtonTeller;
                        newButton.Text = "Als..Dan";
                    }
                    break;

                default:
                    {
                        globalNewButtonTeller--;
                        MessageBox.Show("Sorry! Er is iets mis gegaan met het plaatsen van een nieuwe button");
                    }
                    break;
            }
            this.Controls.Add(newButton);
            newButton.BringToFront();

        }  //code optimized
        
        #endregion

        #region Blokcodescherm

        private void deleteEigenschappen(int bcArrayPosition)
        {
            for (int j = 0; j < maxKolommen; j++)
            {
                for (int k = 0; k < maxDiepte; k++)
                {
                    blokcodeArray[bcArrayPosition, j, k] = "";
                }
            }
        }  //code optimized

        private void arrayregelOmdraaienOmlaag(int bcArrayPositie)
        {
            string[,,] hulpArray = new string[1, maxKolommen, maxDiepte];

            if ((bcArrayPositie + 1) < maxRijen)
            {
                // let op nog een for lus bouwen die ook daadwerkelijk het aantal kolommen maakt ipv statisch 5 nu
                // dit kan ook in een for-loop, maybe is met indexpointer werken voor bcArray nog korter

                hulpArray[0, 0, 0] = blokcodeArray[bcArrayPositie, 0, 0];
                hulpArray[0, 1, 0] = blokcodeArray[bcArrayPositie, 1, 0];
                hulpArray[0, 2, 0] = blokcodeArray[bcArrayPositie, 2, 0];
                hulpArray[0, 3, 0] = blokcodeArray[bcArrayPositie, 3, 0];
                hulpArray[0, 4, 0] = blokcodeArray[bcArrayPositie, 4, 0];

                blokcodeArray[bcArrayPositie, 0, 0] = blokcodeArray[bcArrayPositie + 1, 0, 0];
                blokcodeArray[bcArrayPositie, 1, 0] = blokcodeArray[bcArrayPositie + 1, 1, 0];
                blokcodeArray[bcArrayPositie, 2, 0] = blokcodeArray[bcArrayPositie + 1, 2, 0];
                blokcodeArray[bcArrayPositie, 3, 0] = blokcodeArray[bcArrayPositie + 1, 3, 0];
                blokcodeArray[bcArrayPositie, 4, 0] = blokcodeArray[bcArrayPositie + 1, 4, 0];

                blokcodeArray[bcArrayPositie + 1, 0, 0] = hulpArray[0, 0, 0];
                blokcodeArray[bcArrayPositie + 1, 1, 0] = hulpArray[0, 1, 0];
                blokcodeArray[bcArrayPositie + 1, 2, 0] = hulpArray[0, 2, 0];
                blokcodeArray[bcArrayPositie + 1, 3, 0] = hulpArray[0, 3, 0];
                blokcodeArray[bcArrayPositie + 1, 4, 0] = hulpArray[0, 4, 0];

                vulBcBoxen();
            }
        } // not working properly with als..dan  Steven

        private void arrayregelOmdraaienOmhoog(int bcArrayPositie)
        {
            string[,,] hulpArray = new string[1, maxKolommen, maxDiepte];

            if (bcArrayPositie != 0) // 0 is helemaal boven;
            {
                // let op nog een for lus bouwen die ook daadwerkelijk het aantal kolommen maakt ipv statisch 5 nu
                //functie voor swap met 2,3 of 4 plaatsen maar altijd 2 objecten. bijv. swap2 lopen en begin, swap3 lopen en als..dan  en swap4 als..dan, als..dan.

                // dit kan ook in for-loop, maybe is met indexpointer werken voor bcArray nog korter

                hulpArray[0, 0, 0] = blokcodeArray[bcArrayPositie, 0, 0];
                hulpArray[0, 1, 0] = blokcodeArray[bcArrayPositie, 1, 0];
                hulpArray[0, 2, 0] = blokcodeArray[bcArrayPositie, 2, 0];
                hulpArray[0, 3, 0] = blokcodeArray[bcArrayPositie, 3, 0];
                hulpArray[0, 4, 0] = blokcodeArray[bcArrayPositie, 4, 0];

                blokcodeArray[bcArrayPositie, 0, 0] = blokcodeArray[bcArrayPositie - 1, 0, 0];
                blokcodeArray[bcArrayPositie, 1, 0] = blokcodeArray[bcArrayPositie - 1, 1, 0];
                blokcodeArray[bcArrayPositie, 2, 0] = blokcodeArray[bcArrayPositie - 1, 2, 0];
                blokcodeArray[bcArrayPositie, 3, 0] = blokcodeArray[bcArrayPositie - 1, 3, 0];
                blokcodeArray[bcArrayPositie, 4, 0] = blokcodeArray[bcArrayPositie - 1, 4, 0];

                blokcodeArray[bcArrayPositie - 1, 0, 0] = hulpArray[0, 0, 0];
                blokcodeArray[bcArrayPositie - 1, 1, 0] = hulpArray[0, 1, 0];
                blokcodeArray[bcArrayPositie - 1, 2, 0] = hulpArray[0, 2, 0];
                blokcodeArray[bcArrayPositie - 1, 3, 0] = hulpArray[0, 3, 0];
                blokcodeArray[bcArrayPositie - 1, 4, 0] = hulpArray[0, 4, 0];

                vulBcBoxen();
            }
        } // not working properly with als..dan  Steven

        private bool checkDropLocatie(Button currentButton)
        {
            Boolean DropAllowed = false; 

            Point currentMousePos = Control.MousePosition;
        
            if ((currentMousePos.X > (bcDropBox1.Location.X+ test.X)) && 
                (currentMousePos.X < (bcDropBox1.Location.X + bcDropBox1.Size.Width +test.X)) &&
                (currentMousePos.Y > (bcDropBox1.Location.Y+ test.Y)) &&
                (currentMousePos.Y < (bcDropBox1.Location.Y + bcDropBox1.Size.Height+test.Y)))
            {
                if (currentButton.Text == "Als..Dan")
                {
                    DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox1.Text) - 1);
                }
                else
                {
                    DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox1.Text) - 1);
                }


                if (DropAllowed == true)
                {
                    if ((currentMousePos.X <( 384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox1.Text) -1), 1, 0] =="Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                    {
                        vulBcArray(currentButton, Int32.Parse(bcTellerBox1.Text) - 2); //links = op regel0
                    }
                    else
                        if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox1.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                        {
                            vulBcArray(currentButton, Int32.Parse(bcTellerBox1.Text) - 1); //rechts = op regel1
                        }
                        else
                        {
                            vulBcArray(currentButton, Int32.Parse(bcTellerBox1.Text) - 1); // anders is het een normale en dus op regel 1\
                            
                        }
                }
                else
                {
                    //zet de button terug op oorspronkelijke locatie
                    currentButton.Location = currentPosButton1;
                }
            }
          
            else
            {
                if ((currentMousePos.X > (bcDropBox2.Location.X + test.X)) &&
                (currentMousePos.X < (bcDropBox2.Location.X + bcDropBox2.Size.Width + test.X)) &&
                (currentMousePos.Y > (bcDropBox2.Location.Y + test.Y)) &&
                (currentMousePos.Y < (bcDropBox2.Location.Y + bcDropBox2.Size.Height + test.Y)))
            {
                if (currentButton.Text == "Als..Dan")
                {
                    DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox2.Text) - 1);
                }
                else
                {
                    DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox2.Text) - 1);
                }


                if (DropAllowed == true)
                {
                    if ((currentMousePos.X < (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox2.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                    {
                        vulBcArray(currentButton, Int32.Parse(bcTellerBox2.Text) - 2); //links = op regel1
                    }
                    else
                        if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox2.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                        {
                            vulBcArray(currentButton, Int32.Parse(bcTellerBox2.Text) - 1); //rechts = op regel2
                 
                        }
                        else
                        {
                            vulBcArray(currentButton, Int32.Parse(bcTellerBox2.Text) - 1); // anders is het een normale en dus op regel 1
            
                        }
                }
                else
                {
                    //zet de button terug op oorspronkelijke locatie
                    currentButton.Location = currentPosButton1;
                }
            } 
            
                else
                {
                    if ((currentMousePos.X > (bcDropBox3.Location.X + test.X)) &&
                    (currentMousePos.X < (bcDropBox3.Location.X + bcDropBox3.Size.Width + test.X)) &&
                    (currentMousePos.Y > (bcDropBox3.Location.Y + test.Y)) &&
                    (currentMousePos.Y < (bcDropBox3.Location.Y + bcDropBox3.Size.Height + test.Y)))
                    {
                        if (currentButton.Text == "Als..Dan")
                        {
                            DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox3.Text) - 1);
                        }
                        else
                        {
                            DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox3.Text) - 1);
                        }


                        if (DropAllowed == true)
                        {
                            if ((currentMousePos.X < (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox3.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                            {
                                vulBcArray(currentButton, Int32.Parse(bcTellerBox3.Text) - 2); //links = op regel1
                            }
                            else
                                if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox3.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                {
                                    vulBcArray(currentButton, Int32.Parse(bcTellerBox3.Text) - 1); //rechts = op regel2

                                }
                                else
                                {
                                    vulBcArray(currentButton, Int32.Parse(bcTellerBox3.Text) - 1); // anders is het een normale en dus op regel 1

                                }
                        }
                        else
                        {
                            //zet de button terug op oorspronkelijke locatie
                            currentButton.Location = currentPosButton1;
                        }
                    } 

                    else
                    {
                         if ((currentMousePos.X > (bcDropBox4.Location.X + test.X)) &&
                         (currentMousePos.X < (bcDropBox4.Location.X + bcDropBox4.Size.Width + test.X)) &&
                         (currentMousePos.Y > (bcDropBox4.Location.Y + test.Y)) &&
                         (currentMousePos.Y < (bcDropBox4.Location.Y + bcDropBox4.Size.Height + test.Y)))
                         {
                             if (currentButton.Text == "Als..Dan")
                             {
                                 DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox4.Text) - 1);
                             }
                             else
                             {
                                 DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox4.Text) - 1);
                             }


                             if (DropAllowed == true)
                             {
                                 if ((currentMousePos.X < (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox4.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                 {
                                     vulBcArray(currentButton, Int32.Parse(bcTellerBox4.Text) - 2); //links = op regel1
                                 }
                                 else
                                     if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox4.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                     {
                                         vulBcArray(currentButton, Int32.Parse(bcTellerBox4.Text) - 1); //rechts = op regel2

                                     }
                                     else
                                     {
                                         vulBcArray(currentButton, Int32.Parse(bcTellerBox4.Text) - 1); // anders is het een normale en dus op regel 1

                                     }
                             }
                             else
                             {
                                 //zet de button terug op oorspronkelijke locatie
                                 currentButton.Location = currentPosButton1;
                             }
                         } 

                         else
                         {
                             if ((currentMousePos.X > (bcDropBox5.Location.X + test.X)) &&
                             (currentMousePos.X < (bcDropBox5.Location.X + bcDropBox5.Size.Width + test.X)) &&
                             (currentMousePos.Y > (bcDropBox5.Location.Y + test.Y)) &&
                             (currentMousePos.Y < (bcDropBox5.Location.Y + bcDropBox5.Size.Height + test.Y)))
                             {
                                 if (currentButton.Text == "Als..Dan")
                                 {
                                     DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox5.Text) - 1);
                                 }
                                 else
                                 {
                                     DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox5.Text) - 1);
                                 }


                                 if (DropAllowed == true)
                                 {
                                     if ((currentMousePos.X < (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox5.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                     {
                                         vulBcArray(currentButton, Int32.Parse(bcTellerBox5.Text) - 2); //links = op regel1
                                     }
                                     else
                                         if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox5.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                         {
                                             vulBcArray(currentButton, Int32.Parse(bcTellerBox5.Text) - 1); //rechts = op regel2

                                         }
                                         else
                                         {
                                             vulBcArray(currentButton, Int32.Parse(bcTellerBox5.Text) - 1); // anders is het een normale en dus op regel 1

                                         }
                                 }
                                 else
                                 {
                                     //zet de button terug op oorspronkelijke locatie
                                     currentButton.Location = currentPosButton1;
                                 }
                             } 

                             else
                             {
                                 if ((currentMousePos.X > (bcDropBox6.Location.X + test.X)) &&
                                 (currentMousePos.X < (bcDropBox6.Location.X + bcDropBox6.Size.Width + test.X)) &&
                                 (currentMousePos.Y > (bcDropBox6.Location.Y + test.Y)) &&
                                 (currentMousePos.Y < (bcDropBox6.Location.Y + bcDropBox6.Size.Height + test.Y)))
                                 {
                                     if (currentButton.Text == "Als..Dan")
                                     {
                                         DropAllowed = checkArrayVoorTweePlaatsen(currentButton, Int32.Parse(bcTellerBox6.Text) - 1);
                                     }
                                     else
                                     {
                                         DropAllowed = checkArrayVoorEenPlaats(currentButton, Int32.Parse(bcTellerBox6.Text) - 1);
                                     }


                                     if (DropAllowed == true)
                                     {
                                         if ((currentMousePos.X < (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox6.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                         {
                                             vulBcArray(currentButton, Int32.Parse(bcTellerBox6.Text) - 2); //links = op regel1
                                         }
                                         else
                                             if ((currentMousePos.X > (384 + test.X)) && (blokcodeArray[(Int32.Parse(bcTellerBox6.Text) - 1), 1, 0] == "Nee")) //mag alleen op regel 2 (=nee) van als dan gedrop worden. kleiner dan 384 betekent links droppen  anders rechts
                                             {
                                                 vulBcArray(currentButton, Int32.Parse(bcTellerBox6.Text) - 1); //rechts = op regel2

                                             }
                                             else
                                             {
                                                 vulBcArray(currentButton, Int32.Parse(bcTellerBox6.Text) - 1); // anders is het een normale en dus op regel 1

                                             }
                                     }
                                     else
                                     {
                                         //zet de button terug op oorspronkelijke locatie
                                         currentButton.Location = currentPosButton1;
                                     }
                                 } 

                                 else
                                 {
                                 //zet de button terug op oorspronkelijke locatie
                                 currentButton.Location = currentPosButton1;
                                 }
                             }
                         }
                     }
                 }
            }

            return (DropAllowed);
        } // needs to be revised for errors , because als..dan  = no check should be inside als..dan if    Steven

        private void vulBcArray(Button currentButton, int arrayRij)
        {
            // Deze methode vult de blokcode array met de juiste actie/sensor/overig. Tevens worden hier de default eigenschappen waarden toegekend en een nieuwe dragbutton gemaakt.


            switch (currentButton.Text)
            {
                case "Lopen":
                    {
                        if (blokcodeArray[arrayRij, 0, 0] == "Als..Dan")
                        {
                            blokcodeArray[arrayRij, 0, 1] = "Lopen";
                            blokcodeArray[arrayRij, 1, 1] = "links"; //richting links rechts rechtdoor (dropbox?)
                            blokcodeArray[arrayRij, 2, 1] = "2"; // sec?
                            blokcodeArray[arrayRij, 3, 1] = "100"; //100% power
                            
             //               if (filterJaNee(arrayRij) =="Ja")                    Andy kan deze code weg?
             //                   blokcodeArray[arrayRij, 2, 0] = "eol";
                        }
                        else
                        {
                            blokcodeArray[arrayRij, 0, 0] = "Lopen";
                            blokcodeArray[arrayRij, 1, 0] = "links"; //richting links rechts rechtdoor (dropbox?)
                            blokcodeArray[arrayRij, 2, 0] = "2"; // sec?
                            blokcodeArray[arrayRij, 3, 0] = "100"; //100% power
                            blokcodeArray[arrayRij, 4, 0] = "eol";
                        }

                        createNewDragButton("Lopen");
                    }
                    break;

                case "Praten":
                    {
                        if (blokcodeArray[arrayRij, 0, 0] == "Als..Dan")
                        {
                            blokcodeArray[arrayRij, 0, 1] = "Praten";
                            blokcodeArray[arrayRij, 1, 1] = "Hello"; // keuze uit 3 sounds
                            blokcodeArray[arrayRij, 2, 1] = "1"; // aantal x

            //                if (filterJaNee(arrayRij) == "Ja")                      Andy kan deze code weg?
            //                    blokcodeArray[arrayRij, 2, 0] = "eol";
                        }
                        else
                        {
                            blokcodeArray[arrayRij, 0, 0] = "Praten";
                            blokcodeArray[arrayRij, 1, 0] = "Hello"; // keuze uit 3 sounds
                            blokcodeArray[arrayRij, 2, 0] = "1"; // aantal x
                            blokcodeArray[arrayRij, 3, 0] = "eol";
                        }

                        createNewDragButton("Praten");
                    }
                    break;

                case "Arm/Hoofd":
                    {
                        if (blokcodeArray[arrayRij, 0, 0] == "Als..Dan")
                        {
                            blokcodeArray[arrayRij, 0, 1] = "Arm/Hoofd";
                            blokcodeArray[arrayRij, 1, 1] = "2"; // 10 sec?
                            blokcodeArray[arrayRij, 2, 1] = "100"; //100% power
                            
           //                 if (filterJaNee(arrayRij) == "Ja")                Andy
           //                     blokcodeArray[arrayRij, 2, 0] = "eol";
                        }
                        else
                        {
                            blokcodeArray[arrayRij, 0, 0] = "Arm/Hoofd";
                            blokcodeArray[arrayRij, 1, 0] = "2"; // 10 sec?
                            blokcodeArray[arrayRij, 2, 0] = "100"; //100% power
                            blokcodeArray[arrayRij, 3, 0] = "eol";
                        }

                        createNewDragButton("Arm/Hoofd");
                    }
                    break;

                case "Tekening":
                    {
                        if (blokcodeArray[arrayRij, 0, 0] == "Als..Dan")
                        {
                            blokcodeArray[arrayRij, 0, 1] = "Tekening";
                            blokcodeArray[arrayRij, 1, 1] = "Hartje"; //keuze uit 3 images
                            blokcodeArray[arrayRij, 2, 1] = "10"; //aantal sec

             //               if (filterJaNee(arrayRij) == "Ja")                Andy
             //                   blokcodeArray[arrayRij, 2, 0] = "eol";
                        }
                        else
                        {
                            blokcodeArray[arrayRij, 0, 0] = "Tekening";
                            blokcodeArray[arrayRij, 1, 0] = "Hartje"; //keuze uit 3 images
                            blokcodeArray[arrayRij, 2, 0] = "10"; //aantal sec
                            blokcodeArray[arrayRij, 3, 0] = "eol";
                        }

                        createNewDragButton("Tekening");
                    }
                    break;

                case "Geluid":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Als..Dan"; 
                        blokcodeArray[arrayRij, 1, 0] = "Ja";
                        blokcodeArray[arrayRij, 2, 0] = "Geluid";
                        blokcodeArray[arrayRij, 3, 0] = "50";  // treshold waarde >50 db

                        blokcodeArray[arrayRij +1, 0, 0] = "Als..Dan"; 
                        blokcodeArray[arrayRij +1, 1, 0] = "Nee";
                        blokcodeArray[arrayRij +1, 2, 0] = "Geluid";
                        blokcodeArray[arrayRij +1, 3, 0] = "50"; // treshold waarde >50 db
                        blokcodeArray[arrayRij +1, 4, 0] = "eol";   // Andy staat ie goed en is het nodig?

                        createNewDragButton("Geluid");
                    }
                    break;

                case "Voelknop":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Als..Dan";
                        blokcodeArray[arrayRij, 1, 0] = "Ja";
                        blokcodeArray[arrayRij, 2, 0] = "Voelknop";
                        blokcodeArray[arrayRij, 3, 0] = "1";  // treshold waarde > 1 indrukken


                        blokcodeArray[arrayRij +1, 0, 0] = "Als..Dan"; 
                        blokcodeArray[arrayRij +1, 1, 0] = "Nee";
                        blokcodeArray[arrayRij +1, 2, 0] = "Voelknop";
                        blokcodeArray[arrayRij +1, 3, 0] = "1";  // treshold waarde > 1 indrukken
                        blokcodeArray[arrayRij +1, 4, 0] = "eol";   //Andy 

                        createNewDragButton("Voelknop");
                    }
                    break;

                case "Iets zien":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Als..Dan"; 
                        blokcodeArray[arrayRij, 1, 0] = "Ja";
                        blokcodeArray[arrayRij, 2, 0] = "Iets zien";
                        blokcodeArray[arrayRij, 3, 0] = "20";  // treshold waarde > 20 cm afstand
                        
                        blokcodeArray[arrayRij +1, 0, 0] = "Als..Dan"; 
                        blokcodeArray[arrayRij +1, 1, 0] = "Nee";
                        blokcodeArray[arrayRij +1, 2, 0] = "Iets zien";
                        blokcodeArray[arrayRij +1, 3, 0] = "20";  // treshold waarde > 20 cm afstand
                        blokcodeArray[arrayRij +1, 4, 0] = "eol";   //Andy 
                       
                        createNewDragButton("Iets zien");
                    }
                    break;

                case "Begin":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Begin";
                        blokcodeArray[arrayRij, 1, 0] = "eol";

                        createNewDragButton("Begin");
                    }
                    break;

                case "Einde":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Einde";
                        blokcodeArray[arrayRij, 1, 0] = "eol";

                        createNewDragButton("Einde");
                    }
                    break;

                case "Als..Dan":
                    {
                        blokcodeArray[arrayRij, 0, 0] = "Als..Dan";
                        blokcodeArray[arrayRij, 1, 0] = "Ja";
                        blokcodeArray[arrayRij, 2, 0] = "Leeg";  // sensor zie boven voor voorb.
                        blokcodeArray[arrayRij, 3, 0] = "Leeg";  // treshold waarde  zie boven voor voorb.

                        blokcodeArray[arrayRij +1, 0, 0] = "Als..Dan";
                        blokcodeArray[arrayRij +1, 1, 0] = "Nee";
                        blokcodeArray[arrayRij +1, 2, 0] = "Leeg";  // sensor zie boven voor voorb.
                        blokcodeArray[arrayRij +1, 3, 0] = "Leeg";  // treshold waarde  zie boven voor voorb.
                        blokcodeArray[arrayRij +1, 4, 0] = "eol";   //Andy 

                        createNewDragButton("Als..Dan");
                    }
                    break;

                default:
                    {
                        MessageBox.Show("Sorry! Er is iets mis gegaan met het vullen van de blokcode array");
                    }
                    break;
            }

            int eofPositie = 0;

            for (int i = 0; i < maxRijen; i++)
            {
                if (String.Equals(blokcodeArray[i, 0, 0], "eof"))
                {
                    blokcodeArray[i, 0, 0] = "";
                }
            }

            for (int i = 0; i < maxRijen; i++)
            {
                if (!String.Equals(blokcodeArray[i, 0, 0], "eof") && !String.Equals(blokcodeArray[i, 0, 0], ""))
                    eofPositie = i;
            }
            blokcodeArray[eofPositie + 1, 0, 0] = "eof";

            this.Controls.Remove(currentButton);
            vulBcBoxen();              
        } //code optimized 
        
        private void vulBcBoxen()
        {
            Font fontBold = this.bcTellerBox1.SelectionFont;
            FontStyle style;

            style = FontStyle.Bold;
            Font fontToApply = new Font(fontBold, style);

            fontToApply = new Font(fontBold, style);
            this.bcTellerBox1.SelectionFont = fontToApply;
            this.bcTellerBox2.SelectionFont = fontToApply;
            this.bcTellerBox3.SelectionFont = fontToApply;
            this.bcTellerBox4.SelectionFont = fontToApply;
            this.bcTellerBox5.SelectionFont = fontToApply;
            this.bcTellerBox6.SelectionFont = fontToApply;



            if (globalHuidigLesNummer == 1)
            {
                bcTellerBox1.Text = (globalBcArrayPosition + 1).ToString();
                bcTellerBox2.Text = (globalBcArrayPosition + 2).ToString();
                bcTellerBox3.Text = (globalBcArrayPosition + 3).ToString();

                tekenBoxFunctie(globalBcArrayPosition    , new Point(bcDropBox1.Location.X, bcDropBox1.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 1, new Point(bcDropBox2.Location.X, bcDropBox2.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 2, new Point(bcDropBox3.Location.X, bcDropBox3.Location.Y));
            }
            else
            {
                bcTellerBox1.Text = (globalBcArrayPosition + 1).ToString();
                bcTellerBox2.Text = (globalBcArrayPosition + 2).ToString();
                bcTellerBox3.Text = (globalBcArrayPosition + 3).ToString();
                bcTellerBox4.Text = (globalBcArrayPosition + 4).ToString();
                bcTellerBox5.Text = (globalBcArrayPosition + 5).ToString();
                bcTellerBox6.Text = (globalBcArrayPosition + 6).ToString();

                tekenBoxFunctie(globalBcArrayPosition    , new Point(bcDropBox1.Location.X, bcDropBox1.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 1, new Point(bcDropBox2.Location.X, bcDropBox2.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 2, new Point(bcDropBox3.Location.X, bcDropBox3.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 3, new Point(bcDropBox4.Location.X, bcDropBox4.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 4, new Point(bcDropBox5.Location.X, bcDropBox5.Location.Y));
                tekenBoxFunctie(globalBcArrayPosition + 5, new Point(bcDropBox6.Location.X, bcDropBox6.Location.Y));

                toPseudoBoxCode();
            }
        }  //code optimized

        private int checkButtonLocatie(Point currentButton)
        {
            //check de buttonlocatie voor de juiste box nummer. dropboxnummer komt overeen bctellerbox nummer. geef tellerbox inhoud -1 terug voor de juiste array positie.
            //kan niet in een switch omdat een point geen constante kan zijn en daarom kan de compiler niet in compile time de switch controleren.. any ideas?
            int bcArrayPos = 0;

            if (currentButton.Y == bcDropBox1.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox1.Text) - 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox2.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox2.Text) - 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox3.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox3.Text) - 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox4.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox4.Text) - 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox5.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox5.Text) - 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox6.Location.Y)
            {
                bcArrayPos = Int32.Parse(bcTellerBox6.Text) - 1;
                return (bcArrayPos);
            }
            return (bcArrayPos);
        } //code optimzed

        private int checkFysiekeButtonLocatie(Point currentButton)
        {
            //check de buttonlocatie voor de juiste fysiek box nummer.//kan niet in een switch omdat een point geen constante kan zijn en daarom kan de compiler niet in compile time de switch controleren.. any ideas?
            int bcArrayPos = 0;

            if (currentButton.Y == bcDropBox1.Location.Y)
            {
                bcArrayPos = 1;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox2.Location.Y)
            {
                bcArrayPos = 2;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox3.Location.Y)
            {
                bcArrayPos = 3;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox4.Location.Y)
            {
                bcArrayPos = 4;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox5.Location.Y)
            {
                bcArrayPos = 5;
                return (bcArrayPos);
            }

            if (currentButton.Y == bcDropBox6.Location.Y)
            {
                bcArrayPos = 6;
                return (bcArrayPos);
            }
            return (bcArrayPos);
        } //code optimzed

        private bool checkArrayVoorTweePlaatsen(Button currentButton, int arrayRij)
        {
            bool dropAllowed = true; //moet false zijn 

            if ((blokcodeArray[arrayRij, 0, 0] == "") && (blokcodeArray[arrayRij + 1, 0, 0] == ""))
            {
                dropAllowed = true;
                return (dropAllowed);
            }
            else
                return (dropAllowed);
        } // = overwrite mechanism , not working properly with als..dan  Steven

        private bool checkArrayVoorEenPlaats(Button currentButton, int arrayRij)
        {
            bool dropAllowed = false;

            if ((currentButton.Text == "Geluid") || (currentButton.Text == "Voelknop") || (currentButton.Text == "Iets zien"))
            {
                string sensorWaarde = "test"; // filterSensorWaarde(arrayRij);
                if ((blokcodeArray[arrayRij, 0, 0] == "Als..Dan") && (sensorWaarde == "Leeg"))
                {
                    dropAllowed = true;
                    return (dropAllowed);
                }
                else
                {
                    dropAllowed = true; //true gemaakt voor test
                    return (dropAllowed);
                }
            }


            if ((currentButton.Text == "Lopen") || (currentButton.Text == "Praten") || (currentButton.Text == "Arm/Hoofd") || (currentButton.Text == "Tekening"))
            {
                string actieWaarde = "test"; // = filterActieWaarde(arrayRij);

                if ((blokcodeArray[arrayRij, 0, 0] == "Als..Dan") && (actieWaarde == "Leeg"))
                {
                    dropAllowed = true;
                    return (dropAllowed);
                }
                else
                {
                    if ((blokcodeArray[arrayRij, 0, 0] == "") || (blokcodeArray[arrayRij, 0, 0] == "eof"))
                    {
                        dropAllowed = true;
                        return (dropAllowed);
                    }
                    else
                    {
                        dropAllowed = false; 
                        return (dropAllowed);
                    }
                }
            }

            if (currentButton.Text == "Begin")
            {
                if ((blokcodeArray[arrayRij, 0, 0] == "") ||(blokcodeArray[arrayRij, 0, 0] == "eof"))
                {
                    if (beginIsPlaced == false)
                    {
                        beginIsPlaced = true;
                        dropAllowed = true;
                        return (dropAllowed);
                    }
                    else
                    {
                        MessageBox.Show("Begin mag maar 1x geplaatst worden, verwijder eerst het andere Begin blok");
                        dropAllowed = false;
                        return (dropAllowed);
                    }
                }
                else
                {
                    dropAllowed = false;
                    return (dropAllowed);
                }
            }
             
            if (currentButton.Text == "Einde")
            {
                if ((blokcodeArray[arrayRij, 0, 0] == "") || (blokcodeArray[arrayRij, 0, 0] == "eof"))
                {
                    if (eindeIsPlaced == false)
                    {
                        eindeIsPlaced = true;
                        dropAllowed = true;
                        return (dropAllowed);
                    }
                    else
                    {
                        MessageBox.Show("Einde mag maar 1x geplaatst worden, verwijder eerst het andere Einde blok");
                        dropAllowed = false;
                        return (dropAllowed);
                    }
                }
                else
                {
                    dropAllowed = false;
                    return (dropAllowed);
                }
            }
            return (dropAllowed);
        } // = overwrite mechanism, not working properly with als..dan  Steven

        private void checkEofOmhoog()
        {
            int eofPositie = 0;

            bool eofPlaats = false;

            // zoek Eof positie
            for (int i = 0; i < maxRijen; i++)
            {
                if (String.Equals(blokcodeArray[i, 0, 0], "eof"))
                    eofPositie = i;
            }

            if (eofPositie != 0)
            {
                blokcodeArray[eofPositie, 0, 0] = "";

                if (!String.IsNullOrEmpty(blokcodeArray[eofPositie - 1, 0, 0]))
                {
                    blokcodeArray[eofPositie, 0, 0] = "eof";
                }
                else
                {
                    // zoek hoeveel regels (-1) omhoog mag
                    while (eofPlaats == false)
                    {
                        if (!String.IsNullOrEmpty(blokcodeArray[eofPositie - 1, 0, 0]))
                        {
                            eofPlaats = true;
                            blokcodeArray[eofPositie, 0, 0] = "eof";
                        }
                        else
                        {
                            if (eofPositie > 1)
                            {
                                eofPositie += -1;
                            }
                            else
                            {
                                eofPlaats = true;

                                for (int i = 0; i < maxRijen; i++)
                                {
                                    for (int j = 0; j < maxKolommen; j++)
                                    {
                                        for (int k = 0; k < maxDiepte; k++)
                                        {
                                            blokcodeArray[i, j, k] = "";
                                        }
                                    }
                                }
                                blokcodeArray[0, 0, 0] = "eof";
                            }
                        }

                    }
                }
            }
        }  //code optimized

        #endregion

        #region Eigenschappenscherm (oa. Andy)

        #region Andy // Andy can you check all this code for code optimization and correctness with Als..Dan


        #region blokCode gedeelte

        private void toPseudoBoxCode()
        {
            pseudoBox.Text = ""; // maak pseudoBox leeg
            #region comment
            /*
            Font fontOfTest = this.pseudoBox.SelectionFont;
            FontStyle styleOfTest;
            styleOfTest = FontStyle.Bold;
            Color colorOfTest = this.pseudoBox.SelectionColor;
            colorOfTest = Color.Red;
            
            Font fontToApply = new Font(fontOfTest, styleOfTest);
            this.pseudoBox.SelectionFont = fontToApply;
            this.pseudoBox.SelectionColor = colorOfTest;
            pseudoBox.SelectedText = "bold, red text" + Environment.NewLine;

            styleOfTest = FontStyle.Regular;
            fontToApply = new Font(fontOfTest, styleOfTest);

            this.pseudoBox.SelectionFont = fontToApply;
            this.pseudoBox.SelectionColor = Color.Blue;
            pseudoBox.SelectedText = "hierna blauwe text normaal font" + Environment.NewLine;
*/
            #endregion // end comment

            int i = 0;

            while (!String.Equals(blokcodeArray[i, 0, 0], "eof") && i < (maxRijen-1))  //Andy klopt die -1?
            {
                zinToPseudoCode(i);
                i++;
            }
        }

        private void normaalStyle()
        {
            Font font = this.pseudoBox.SelectionFont;
            FontStyle style;

            style = FontStyle.Regular;
            Font fontToApply = new Font(font, style);

            fontToApply = new Font(font, style);
            this.pseudoBox.SelectionFont = fontToApply;
            this.pseudoBox.SelectionColor = Color.Black;
        }

        private void actiesStyle()
        {
            Font font = this.pseudoBox.SelectionFont;
            FontStyle style;

            style = FontStyle.Bold;
            Font fontToApply = new Font(font, style);

            fontToApply = new Font(font, style);
            this.pseudoBox.SelectionFont = fontToApply;
            this.pseudoBox.SelectionColor = Color.Green;
        }

        private void sensorenStyle()
        {
            Font font = this.pseudoBox.SelectionFont;
            FontStyle style;

            style = FontStyle.Bold;
            Font fontToApply = new Font(font, style);

            fontToApply = new Font(font, style);
            this.pseudoBox.SelectionFont = fontToApply;
            this.pseudoBox.SelectionColor = Color.Blue;
        }

        private void zinToPseudoCode(int positie)
        {
            string[] parameters = getParameterArray(positie);

            switch (blokcodeArray[positie, 0, 0])
            {
                case "Lopen":
                    {
                        string richting = parameters[0];

                        if (parameters[0].Equals("links") || parameters[0].Equals("rechts"))
                            richting = "naar " + parameters[0];

                        pseudoBox.SelectedText = "Max ";
                        actiesStyle();
                        pseudoBox.SelectedText = "loopt " + richting;
                        normaalStyle();
                        pseudoBox.SelectedText = " en zet ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[1];
                        normaalStyle();
                        pseudoBox.SelectedText = " stappen op snelheid ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[2] + "%";
                        normaalStyle();
                        pseudoBox.SelectedText = "." + Environment.NewLine;
                        break;
                    }
                case "Praten":
                    {
                        string zin = "niks.";
                        if (String.Equals(parameters[0], "Hallo"))
                            zin = "Hallo ik ben Max.";
                        else
                            zin = parameters[0];

                        normaalStyle();
                        pseudoBox.SelectedText = "Max";
                        actiesStyle();
                        pseudoBox.SelectedText = " zegt: \"" + zin + "\"";
                        normaalStyle();
                        pseudoBox.SelectedText = ", voor ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[1];
                        normaalStyle();
                        pseudoBox.SelectedText = " seconde(n)." + Environment.NewLine;
                        break;
                    }
                case "Arm/Hoofd":
                    {
                        normaalStyle();
                        pseudoBox.SelectedText = "Max ";
                        actiesStyle();
                        pseudoBox.SelectedText = " beweegt zijn hoofd en armen ";
                        normaalStyle();
                        pseudoBox.SelectedText = "voor ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[0];
                        normaalStyle();
                        pseudoBox.SelectedText = " seconden op ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[1] + "% ";
                        normaalStyle();
                        pseudoBox.SelectedText = "snelheid." + Environment.NewLine;
                        break;
                    }
                case "Tekening":
                    {
                        normaalStyle();
                        pseudoBox.SelectedText = "Max ";
                        actiesStyle();
                        pseudoBox.SelectedText = "toont ";
                        normaalStyle();
                        pseudoBox.SelectedText = "het plaatje van een ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[0];
                        normaalStyle();
                        pseudoBox.SelectedText = " op zijn borst voor ";
                        actiesStyle();
                        pseudoBox.SelectedText = parameters[1];
                        normaalStyle();
                        pseudoBox.SelectedText = " seconden." + Environment.NewLine;
                        break;
                    }
                case "Geluid":
                    {
                        pseudoBox.SelectedText = "Max reageert op geluid van " + parameters[0] + " db." + Environment.NewLine;
                        break;
                    }
                case "Voelknop":
                    {
                        normaalStyle();
                        pseudoBox.SelectedText = "Max ";
                        normaalStyle();
                        pseudoBox.SelectedText = "reageert op " + parameters[0] + " keer drukken." + Environment.NewLine;
                        break;
                    }
                case "Iets zien":
                    {
                        pseudoBox.SelectedText = "Max reageert op beweging van " + parameters[0] + " cm afstand.";
                        break;
                    }
                case "Begin":
                    {
                        pseudoBox.SelectedText = "Max wordt wakker om te beginnen." + Environment.NewLine;
                        break;
                    }
                case "Einde":
                    {
                        pseudoBox.SelectedText = "Max gaat slapen." + Environment.NewLine;
                        break;
                    }

                default:
                    {
                        pseudoBox.SelectedText = "Lege regel." + Environment.NewLine;
                        break;
                    }
            }
        }
        #endregion // blokCode gedeelte

        private string[] getParameterArray(int curr)
        {
            // tel aantal parameters;
            int i = 1;

            while (!String.Equals(blokcodeArray[curr, i, 0], "eol") && i < 4)
            {
                i++;
            }

            string[] parameterArray = new string[i - 1];

            // vul parameterArray
            i = 0;
            while (!String.Equals(blokcodeArray[curr, i +1, 0], "eol") && i < 3)
            {
                parameterArray[i] = blokcodeArray[curr, i +1, 0];
                i++;
            }

            return parameterArray;
        }

        private string[] getParameterNamen(int bcArrayPositie, int esArrayPositie)
        {
            Acties actie;
            if (String.Equals(blokcodeArray[bcArrayPositie, 0, 0], "Als..Dan"))
            {
                actie = new Acties(filterSensorWaarde(bcArrayPositie),filterSensorParameters(blokcodeArray[bcArrayPositie, 1, 0]));
             // actie = new Acties(blokcodeArray[bcArrayPositie, 2, 0], blokcodeArray[bcArrayPositie, 3, 0]); //Andy de laatste parameter zorgt voor een fout omdat maar 1 parameter doorgegeven wordt en er een aantal (string[]) gevraagd wordt.
                // voor debuggen
                string[] t = filterSensorParameters(blokcodeArray[bcArrayPositie, 1, 0]);
                // debuggerBox.Text += "getParameterNamen: " + filterSensorWaarde(bcArrayPositie) + ", " + t[0] + Environment.NewLine;
            }
            else
            {
                actie = new Acties(blokcodeArray[bcArrayPositie, 0, 0],
                getParameterArray(bcArrayPositie));
            }

            string[] labels = actie.actieLabels;

            return labels;
        }

        private void esLeeg(int arrayRij)
        {
            // Alleen leeg maken indien niet al leeg. en als als dan geval is twee regels leeg maken.
            if (blokcodeArray[arrayRij, 0, 0] == "Als..Dan")
            {
                if (blokcodeArray[arrayRij, 1, 0] == "Ja")
                {
                    deleteEigenschappen(arrayRij);
                    deleteEigenschappen(arrayRij + 1);
                }
                else
                {
                    deleteEigenschappen(arrayRij);
                    deleteEigenschappen(arrayRij - 1);
                }
            }
            else
            {
                if (blokcodeArray[arrayRij, 0, 0] != "eof")
                {
                    if (blokcodeArray[arrayRij, 0, 0] == "Begin")
                    {
                        beginIsPlaced = false;
                        deleteEigenschappen(arrayRij);
                    }
                    else
                    {
                        if (blokcodeArray[arrayRij, 0, 0] == "Einde")
                        {
                            eindeIsPlaced = false;
                            deleteEigenschappen(arrayRij);
                        }
                        else
                        {
                            deleteEigenschappen(arrayRij);
                        }
                    }
                }
            }

            if (arrayRij == globalHulpVoorRijPositie)
            {
                esPlaatje.BackgroundImage = null;
                esPlaatje.Text = "";
                esDropWaardeBox1.Text = "";
                esDropWaardeBox2.Text = "";
                esBox1.Text = "";
                esBox2.Text = "";
            }
        } //code optimzed + works with 3D Array
     
        #endregion

        private void vulEsBoxen(int bcArrayPositie, int esArrayPositie)
        {
            esDropWaardeBox1.Text = blokcodeArray[bcArrayPositie, esArrayPositie, 0];
            esDropWaardeBox2.Text = blokcodeArray[bcArrayPositie, esArrayPositie + 1, 0];

            if (!String.IsNullOrEmpty(blokcodeArray[bcArrayPositie, 0, 0]) &&
            !String.Equals(blokcodeArray[bcArrayPositie, 0, 0], "eof"))
            {
                string[] parameterNamen = getParameterNamen(bcArrayPositie, esArrayPositie);

                if (esArrayPositie < parameterNamen.Length)
                {
                    esBox1.Text = parameterNamen[esArrayPositie - 1];
                    esBox2.Text = parameterNamen[esArrayPositie];
                }
            }

            //moet onderaan staan!
            globalHulpVoorRijPositie = bcArrayPositie;
        } // not working properly with als..dan  Steven

        private void esWaardeBox1_TextChanged(object sender, EventArgs e)
        {
            if (changeSemafoor == true)
                blokcodeArray[globalHulpVoorRijPositie, globalEsArrayPosition, 0] = esDropWaardeBox1.Text;
            
            toPseudoBoxCode();
        } //code optimzed

        private void esWaardeBox2_TextChanged(object sender, EventArgs e)
        {
            if (changeSemafoor == true)
                blokcodeArray[globalHulpVoorRijPositie, globalEsArrayPosition +1, 0] = esDropWaardeBox2.Text;

            toPseudoBoxCode();
        } //code optimzed
        #endregion
       


        #region Opbouwen/Afsluiten Bluetooth connection [small problem here Kenneth]
        
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            tf = new Transformer(blokcodeArray, nxtBrick1, nxtMotorA, nxtMotorB, nxtMotorC, nxtSoundSensor1, nxtPressureSensor1);
            nxtBrick1.Connect();

        } // problem: application (mainForm) will not start if Robot is not turned on and accepting bluetooth connection. 
       //  * mainForm must show under any circumstance!!! Solution: maybe something with an empty form where all of Brams nxtBrick stuff is placed. Activate ( but not show) form by using multi threading    Kenneth
       //  * maybe put nxtbrick1.connect and tf = new transformer etc under bouw button click. Otherwise program will crash if no new transformer instance is activated. Right after all robot activity close bluetooth connection (instead of exit of program)to save battery.

        protected override void OnClosing(CancelEventArgs e)
        {
            nxtBrick1.Disconnect();
            base.OnClosing(e);
        }  //code optimized
       
  
        #endregion

        #region Teken Functies        // misschien een teken class maken?

        private void tekenBoxFunctie(int arrayRij, Point dropBoxLocatie)
        {
            string soortButton = blokcodeArray[arrayRij, 0, 0];
            int boxNummer_fysiek = 0;
            Button newButton = new Button();
            globalNewButtonTeller += 1;

            newButton.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
            newButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            newButton.Location = dropBoxLocatie;
            newButton.TabIndex = 24 + globalNewButtonTeller;
            newButton.UseVisualStyleBackColor = false;
            newButton.Size = bcDropBox1.Size;
            newButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(220)))), ((int)(((byte)(240)))), ((int)(((byte)(249)))));

            boxNummer_fysiek = checkFysiekeButtonLocatie(dropBoxLocatie);
            tekenAlsDanBoxLijnNiet(boxNummer_fysiek);

            switch (soortButton)
            {
                case "Lopen":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokLopen_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Lopen";
                        newButton.Name = "lopenButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Praten":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokLopen_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Praten";
                        newButton.Name = "pratenButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Arm/Hoofd":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokLopen_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Arm/Hoofd";
                        newButton.Name = "armHoofdButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Tekening":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokLopen_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Tekening";
                        newButton.Name = "tekeningButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Geluid":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokSensoren_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Geluid";
                        newButton.Name = "geluidButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Voelknop":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokSensoren_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Voelknop";
                        newButton.Name = "voelknopButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Iets zien":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokSensoren_groot_16Bits2;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Iets zien";
                        newButton.Name = "ietszienButton" + globalNewButtonTeller;
                        newButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Begin":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokBegin_groot_16bits;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Begin";
                        newButton.Name = "beginButton" + globalNewButtonTeller;
                    }
                    break;

                case "Einde":
                    {
                        newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokBegin_groot_16bits;
                        newButton.BackgroundImageLayout = ImageLayout.Stretch;
                        newButton.Text = "Einde";
                        newButton.Name = "eindeButton" + globalNewButtonTeller;
                    }
                    break;

                case "Als..Dan":
                    {
                        if (blokcodeArray[arrayRij, 1, 0] == "Ja")
                        {
                            string sensorWaarde;
                            sensorWaarde = blokcodeArray[arrayRij, 2, 0];

                            newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokAlsdan_blauw_16bits; // Als dan ja achtergrond plaatje
                            newButton.BackgroundImageLayout = ImageLayout.Stretch;
                            newButton.Name = "alsdanButton" + globalNewButtonTeller;
                            this.Controls.Add(newButton);
                            newButton.BringToFront();

                            Button newSensorButton = new Button();
                            globalNewButtonTeller += 1;
                            newSensorButton.Name = newSensorButton.Name = "sensorButton" + globalNewButtonTeller;
                            newSensorButton.ImageIndex = 1;
                            newSensorButton.ImageList = this.imageList1;
                            newSensorButton.Location = new Point(dropBoxLocatie.X + 49, dropBoxLocatie.Y + 6);
                            newSensorButton.Size = new System.Drawing.Size(71, 23);
                            newSensorButton.FlatStyle = FlatStyle.Flat;
                            newSensorButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(230)))), ((int)(((byte)(214)))), ((int)(((byte)(25)))));
                            newSensorButton.FlatAppearance.BorderSize = 0;
                            newSensorButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);

                            if (sensorWaarde == "Geluid")
                            {
                                newSensorButton.Text = "Geluid";
                            }
                            else
                            {
                                if (sensorWaarde == "Voelknop")
                                {
                                    newSensorButton.Text = "VoelKnop";
                                }
                                else
                                {
                                    if (sensorWaarde == "Iets zien")
                                    {
                                        newSensorButton.Text = "Iets zien";
                                    }
                                }
                            }

                            this.Controls.Add(newSensorButton);
                            newSensorButton.BringToFront();

                        }
                        else //filter == nee  dus dit is regel2 van als dan
                        {
                            newButton.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokAlsdan_blauw2_16bits;  // Als dan nee achtergrond plaatje
                            newButton.BackgroundImageLayout = ImageLayout.Stretch;
                            newButton.Name = "alsdanButton" + globalNewButtonTeller;

                            this.Controls.Add(newButton);
                            newButton.BringToFront();
                            tekenAlsDanBoxLijnWel(boxNummer_fysiek);

                            tekenAlsDanLinksButton(arrayRij, dropBoxLocatie);
                            tekenAlsDanRechtsButton(arrayRij, dropBoxLocatie);
                        }
                    }
                    break;

                default:
                    {
                        newButton.Text = "";
                        newButton.Name = "legeButton" + globalNewButtonTeller;
                    }
                    break;
            }

            if (soortButton == "Als..Dan")
            {
                //doe nix
            }
            else
            {
                this.Controls.Add(newButton);
                newButton.BringToFront();
            }
        }

        private void tekenAlsDanLinksButton(int arrayRij, Point dropBoxLocatie)
        {
            string actieWaardeButtonLinks;
            actieWaardeButtonLinks = blokcodeArray[arrayRij - 1, 0, 1]; // 1e als..dan actie (actie bij Ja )

            Button newMiniButton = new Button();
            globalNewButtonTeller += 1;

            newMiniButton.FlatStyle = FlatStyle.Flat;
            newMiniButton.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(230)))), ((int)(((byte)(214)))), ((int)(((byte)(25)))));
            newMiniButton.FlatAppearance.BorderSize = 0;
            newMiniButton.Size = new System.Drawing.Size(75, 23);
            newMiniButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
            newMiniButton.Location = new Point(dropBoxLocatie.X + 4, dropBoxLocatie.Y + 20);

            switch (actieWaardeButtonLinks)
            {
                case "Lopen":
                    {
                        newMiniButton.ImageIndex = 2;
                        newMiniButton.ImageList = this.imageList1;
                        newMiniButton.Text = "Lopen";
                        newMiniButton.Name = "lopenButton" + globalNewButtonTeller;
                        newMiniButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Praten":
                    {
                        newMiniButton.ImageIndex = 2;
                        newMiniButton.ImageList = this.imageList1;
                        newMiniButton.Text = "Praten";
                        newMiniButton.Name = "pratenButton" + globalNewButtonTeller;
                        newMiniButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Arm/Hoofd":
                    {
                        newMiniButton.ImageIndex = 2;
                        newMiniButton.ImageList = this.imageList1;
                        newMiniButton.Text = "Arm/Hoofd";
                        newMiniButton.Name = "armHoofdButton" + globalNewButtonTeller;
                        newMiniButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Tekening":
                    {
                        newMiniButton.ImageIndex = 2;
                        newMiniButton.ImageList = this.imageList1;
                        newMiniButton.Text = "Tekening";
                        newMiniButton.Name = "tekeningButton" + globalNewButtonTeller;
                        newMiniButton.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                default:
                    {
                        newMiniButton.ImageIndex = 2;
                        newMiniButton.ImageList = this.imageList1;
                        newMiniButton.Text = "";
                        newMiniButton.Name = "legeButton" + globalNewButtonTeller;
                    }
                    break;
            }
            this.Controls.Add(newMiniButton);
            newMiniButton.BringToFront();
        }

        private void tekenAlsDanRechtsButton(int arrayRij, Point dropBoxLocatie)
        {
            string actieWaardeButtonRechts;
            actieWaardeButtonRechts = blokcodeArray[arrayRij, 0, 1]; // 2e als..dan actie (actie bij Nee )

            Button newMiniButton2 = new Button(); // voor rechts
            globalNewButtonTeller += 1;

            newMiniButton2.FlatStyle = FlatStyle.Flat;
            newMiniButton2.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(230)))), ((int)(((byte)(214)))), ((int)(((byte)(25)))));
            newMiniButton2.FlatAppearance.BorderSize = 0;
            newMiniButton2.Location = new Point(dropBoxLocatie.X + 90, dropBoxLocatie.Y + 20);
            newMiniButton2.Size = new System.Drawing.Size(75, 23);

            switch (actieWaardeButtonRechts)
            {
                case "Lopen":
                    {
                        newMiniButton2.ImageIndex = 2;
                        newMiniButton2.ImageList = this.imageList1;
                        newMiniButton2.Text = "Lopen";
                        newMiniButton2.Name = "lopenButton" + globalNewButtonTeller;
                        newMiniButton2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Praten":
                    {
                        newMiniButton2.ImageIndex = 2;
                        newMiniButton2.ImageList = this.imageList1;
                        newMiniButton2.Text = "Praten";
                        newMiniButton2.Name = "pratenButton" + globalNewButtonTeller;
                        newMiniButton2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Arm/Hoofd":
                    {
                        newMiniButton2.ImageIndex = 2;
                        newMiniButton2.ImageList = this.imageList1;
                        newMiniButton2.Text = "Arm/Hoofd";
                        newMiniButton2.Name = "armHoofdButton" + globalNewButtonTeller;
                        newMiniButton2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                case "Tekening":
                    {
                        newMiniButton2.ImageIndex = 2;
                        newMiniButton2.ImageList = this.imageList1;
                        newMiniButton2.Text = "Tekening";
                        newMiniButton2.Name = "tekeningButton" + globalNewButtonTeller;
                        newMiniButton2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;

                default:
                    {
                        newMiniButton2.ImageIndex = 2;
                        newMiniButton2.ImageList = this.imageList1;
                        newMiniButton2.Text = "";
                        newMiniButton2.Name = "legeButton" + globalNewButtonTeller;
                        newMiniButton2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dragButton_MouseDown);
                    }
                    break;
            }
            this.Controls.Add(newMiniButton2);
            newMiniButton2.BringToFront();
        }

        private void tekenAlsDanBoxLijnWel(int boxNummer)
        {
            switch (boxNummer)
            {
                case 1:
                    {
                        alsdanLijn1.Visible = true;
                        alsdanLijn1.BringToFront();
                    }
                    break;

                case 2:
                    {
                        alsdanLijn2.Visible = true;
                        alsdanLijn2.BringToFront();
                    }
                    break;

                case 3:
                    {
                        alsdanLijn3.Visible = true;
                        alsdanLijn3.BringToFront();
                    }
                    break;

                case 4:
                    {
                        alsdanLijn4.Visible = true;
                        alsdanLijn4.BringToFront();
                    }
                    break;

                case 5:
                    {
                        alsdanLijn5.Visible = true;
                        alsdanLijn5.BringToFront();
                    }
                    break;

                case 6:
                    {
                        alsdanLijn6.Visible = true;
                        alsdanLijn6.BringToFront();
                    }
                    break;

                default:
                    {
                    }
                    break;
            }

        }

        private void tekenAlsDanBoxLijnNiet(int boxNummer)
        {
            switch (boxNummer)
            {
                case 1:
                {
                    alsdanLijn1.Visible = false;
                }
                break;

                case 2:
                {
                    alsdanLijn2.Visible = false;
                }
                break;

                case 3:
                {
                    alsdanLijn3.Visible = false;
                }
                break;

                case 4:
                {
                    alsdanLijn4.Visible = false;
                }
                break;

                case 5:
                {
                    alsdanLijn5.Visible = false;
                }
                break;

                case 6:
                {
                    alsdanLijn6.Visible = false;
                }
                break;

            default:
                {
                }
                break;
            }

        }

        private void tekenEigenschapPlaatje(Button currentButton)
        {
            esPlaatje.BackgroundImageLayout = ImageLayout.Stretch;
            esPlaatje.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            esPlaatje.Text = currentButton.Text;
            if ((currentButton.Size == new System.Drawing.Size(75, 23)) && ((currentButton.Text == "Lopen") || (currentButton.Text == "Praten") || (currentButton.Text == "Arm/Hoofd") || (currentButton.Text == "Tekening")))
            {
                esPlaatje.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokLopen_groot_16Bits2;
            }
            else
            {
                if ((currentButton.Size == new System.Drawing.Size(71, 23)) && ((currentButton.Text == "Geluid") || (currentButton.Text == "Voelknop") || (currentButton.Text == "Iets zien")))
                {
                    esPlaatje.BackgroundImage = global::MaxdeRobot.Properties.Resources.blokSensoren_groot_16Bits2;
                }
                else
                {
                    esPlaatje.BackgroundImage = currentButton.BackgroundImage;
                }
            }
        } //code optimized

        #endregion

        #region Menu functies

        private void nieuwMaxFile()
        {
            FileStream maxFile = new FileStream("Maxnieuw.max", FileMode.Create, FileAccess.ReadWrite);
            StreamWriter maxfileStream = new StreamWriter(maxFile);
            /*
            maxfileStream.WriteLine("1. ");
            maxfileStream.WriteLine("2. ");
            maxfileStream.WriteLine("3. ");
            maxfileStream.WriteLine("4. ");
            maxfileStream.WriteLine("5. ");
            maxfileStream.WriteLine("6. ");
            maxfileStream.Close();
            */

            for (int i = 0; i < maxRijen; i++)
            {
                for (int j = 0; j < maxKolommen; j++)
                {
                    for (int k = 0; k < maxDiepte; k++)
                    {
                        blokcodeArray[i, j, k] = "";
                        //     maxfileStream.WriteLine("");
                    }
                }
            }
            maxfileStream.Close();
            maxFile.Close();

            blokcodeArray[0, 0, 0] = "eof";
            vulBcBoxen();
            toPseudoBoxCode();
        }

         #endregion

        #region Levels    // nog een class van maken

        private void setLevel(string level)
        {
            switch (level)
            {
                case "beginner":
                    {
                        setLes(1);
                    }
                    break;

                case "gevorderde":
                    {
                 //       setLes(10);
                    }
                    break;

                case "expert":
                    {
                //        setLes(13);
                    }
                    break;

                default:
                    {
                    }
                    break;
            }
            vulBcBoxen();
        }

        private void setLes(int lesnummer)
        {
           nieuwMaxFile();

           switch (lesnummer)
            {
                case 1:
                    {                     
                        // introduceert actie Button lopen, 
                        globalHuidigLesNummer = 1;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();
                     
                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 1";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 66);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_1blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 280);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermLes1_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 183);
                        infoPB.Size = new Size(161, 360);
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 192);
                        infoTextBox.Size = new Size(145, 340);
                        infoTextBox.Visible = true;
                        infoTextBox.Text = "";

                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 1: Laat Max lopen." + Environment.NewLine; 

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Laat Max lopen door het groene blokje Lopen te slepen naar het lege vak tussen Begin en Einde. Druk daarna op de Bouw knop. Klik als je klaar bent, op de Volgende les pijl, links boven in het scherm";
                        infoTextBox.SelectedText = Environment.NewLine + Environment.NewLine + "Slepen betekent met de muis over de knop Lopen, vervolgens de linkermuis knop indrukken EN ingedrukt houden, dan de muis bewegen naar het lege vak en tenslotte de linkermuis knop los laten.";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.None;
                        infoTextBox.BringToFront();


                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
  
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = false;
                        regel2DeleteButton.Visible = false;
                        regel3DeleteButton.Visible = false;
                        regel4DeleteButton.Visible = false;
                        regel5DeleteButton.Visible = false;
                        regel6DeleteButton.Visible = false;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = false;
                        bcTellerBox5.Visible = false;
                        bcTellerBox6.Visible = false;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = false;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[2, 0, 0] = "Einde";
                        blokcodeArray[2, 1, 0] = "eol";
                        blokcodeArray[3, 0, 0] = "eof";
                    }
                    break;

                case 2:
                    {
                        //introduceert actiebutton praten
                        globalHuidigLesNummer = 2;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();

                       // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 2";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();
                        
                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 92);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_2blok_24bits; ;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermZonderScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 209);
                        infoPB.Size = new Size(161, 334);
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 218);
                        infoTextBox.Size = new Size(145, 314);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;


                        infoTextBox.SelectedText = "Les 2: Laat Max praten en lopen." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Max kan nog niet praten, sla deze les over!";
                       // infoTextBox.SelectedText = "Sleep eerst het blokje praten naar een van de lege vakjes. Daarna het blokje lopen. Klik tenslotte op Bouw. Zie je in welke volgorde Max de acties uitvoert?";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                   
                     
                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = false;
                        regel2DeleteButton.Visible = false;
                        regel3DeleteButton.Visible = false;
                        regel4DeleteButton.Visible = false;
                        regel5DeleteButton.Visible = false;
                        regel6DeleteButton.Visible = false;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = false;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";
                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 3:
                    {
                        //introduceert actiebutton arm/hoofd
                        globalHuidigLesNummer = 3;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();

                       // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 3";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 118);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_3blok_24bits;
                        
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermZonderScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 235);
                        infoPB.Size = new Size(161, 308);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 244);
                        infoTextBox.Size = new Size(145, 288);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 3: Laat Max eerst lopen en daarna met zijn armen zwaaien." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                   
                        infoTextBox.SelectedText = "Sleep eerst het blokje Lopen naar een van de lege vakjes. Daarna het blokje Arm/Hoofd. Klik tenslotte op Bouw.";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();
                        
                        
                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = false;
                        regel2DeleteButton.Visible = false;
                        regel3DeleteButton.Visible = false;
                        regel4DeleteButton.Visible = false;
                        regel5DeleteButton.Visible = false;
                        regel6DeleteButton.Visible = false;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = false;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";
                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 4:
                    {
                        // introduceert actiebutton tekening 

                        globalHuidigLesNummer = 4;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();

                       // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 4";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermZonderScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 282);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 262);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 4: Laat Max een tekening op zijn buik maken." + Environment.NewLine;
                       

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Max kan nog niet een tekening laten zien, sla deze les over!";
                       // infoTextBox.SelectedText = "Sleep het blokje Tekening naar een van de lege vakjes. Sleep daarna het blokje Praten in een leeg vakje. Klik tenslotte op Bouw.";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();


                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = false;
                        regel2DeleteButton.Visible = false;
                        regel3DeleteButton.Visible = false;
                        regel4DeleteButton.Visible = false;
                        regel5DeleteButton.Visible = false;
                        regel6DeleteButton.Visible = false;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = false;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";
                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 5:
                    {
                        //introduceert pseudobox
                        globalHuidigLesNummer = 5;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 5";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermZonderScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 282);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 262);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 5: Het uitlegscherm van Max." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Sleep een blokje Lopen naar vakje 2. Lees wat er nu staat in het blokcode uitlegscherm. Sleep nu het blokje Praten naar vakje 4. Zie je wat er gebeurd in het uitleg scherm? Er is nu ook een leeg vakje. Klik op Bouw en zie wat er gebeurd met het lege vakje." + Environment.NewLine;
                        infoTextBox.SelectedText = Environment.NewLine + "Hij is leeg, dus Max slaat hem over!!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

       
                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();
                        pseudoBox.BringToFront();
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = false;
                        regel2DeleteButton.Visible = false;
                        regel3DeleteButton.Visible = false;
                        regel4DeleteButton.Visible = false;
                        regel5DeleteButton.Visible = false;
                        regel6DeleteButton.Visible = false;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";
                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 6:
                    {
                        //les introduceert deletebuttons EN begin en einde
                        globalHuidigLesNummer = 6;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();
                        eindeIsPlaced = false;
                        beginIsPlaced = false;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 6";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(267, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermZonderScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 6: Alle blokjes moeten tussen Begin en Einde." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Klik eerst op Bouw. Max is niet zo slim en weet niet wanneer hij moet beginnen en stoppen, daarom moet jij dat eerst vertellen. Klik op het kruisje naast vakje 1. Sleep nu het blokje begin in vakje 1. Sleep daarna het actieblokje Praten in vakje 2. Sleep vervolgens het blokje Einde in vakje 3. Klik tenslotte op Bouw.";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                       
                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45,383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        pseudoBox.BringToFront();
                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = false;
                        bcDownButton.Visible = false;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Lopen";
                        blokcodeArray[0, 1, 0] = "links"; //richting links rechts rechtdoor (dropbox?)
                        blokcodeArray[0, 2, 0] = "2"; // sec?
                        blokcodeArray[0, 3, 0] = "100"; //100% power
                        blokcodeArray[0, 4, 0] = "eol";
                        
                        blokcodeArray[1, 0, 0] = "eof";
                    }
                    break;

                case 7:
                    {
                        //les introduceert up down van blokcode
                        globalHuidigLesNummer = 7;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();
                        eindeIsPlaced = true;
                        beginIsPlaced = true;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 7";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 7: Max kan 20 vakjes onthouden." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Sleep eerst een Begin blokje op vakje 1. Vul het tweede vakje met het blokje Lopen en het derde vakje met het blokje Praten. Kijk nu naar de nummer 1 tot en met 6 naast de vakjes.  Klik nu 1x op het pijltje naar beneden en zie dat de nummers nu van 2 tot en met 7 lopen. Max kan 20 nummers onthouden. Let wel op! Alle acties moeten tussen Begin en Einde blokken. Sleep zelf actie blokjes in vakje 4,5 en 6. Vul vakje 7 met het Einde blokje en klik op Bouw.";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();
                      
                        
                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = false;
                        regel2UpButton.Visible = false;
                        regel3UpButton.Visible = false;
                        regel4UpButton.Visible = false;
                        regel5UpButton.Visible = false;
                        regel6UpButton.Visible = false;

                        regel1DownButton.Visible = false;
                        regel2DownButton.Visible = false;
                        regel3DownButton.Visible = false;
                        regel4DownButton.Visible = false;
                        regel5DownButton.Visible = false;
                        regel6DownButton.Visible = false;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                    }
                    break;

                case 8:
                    {
                        //les introduceert regels up down van blokcodescherm
                        globalHuidigLesNummer = 8;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();
                        eindeIsPlaced = true;
                        beginIsPlaced = true;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauBeginner_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 8";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 8: Regels omdraaien zonder het kruisje te gebruiken." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Max kan makelijk blokjes omdraaien, zonder op het kruisje te drukken en opnieuw te slepen. Klik op het pijltje naar beneden naast vak 1 en zie dat Lopen naar beneden gaat en Begin naar boven. Nu zijn ze heel snel omgedraaid! Klik nu op het pijltje naar boven naast het vakje van Einde. Klik nu op het pijltje naar boven van vakje 5. Klik elke keer op het pijltje naar boven totdat Einde onder het blokje Lopen staat. Klik daarna op Bouw. Vergeet niet dat Max 20 vakjes kan onthouden maar dat je er maar 6 ziet op je scherm!!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();
                        

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = false;
                        esDropWaardeBox1.Visible = false;
                        esDropWaardeBox2.Visible = false;
                        esUpButton.Visible = false;
                        esDownButton.Visible = false;
                        esBox1.Visible = false;
                        esBox2.Visible = false;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");

                        //vul bcArray
                        blokcodeArray[0, 0, 0] = "Lopen";
                        blokcodeArray[0, 1, 0] = "links"; //richting links rechts rechtdoor (dropbox?)
                        blokcodeArray[0, 2, 0] = "2"; // sec?
                        blokcodeArray[0, 3, 0] = "100"; //100% power
                        blokcodeArray[0, 4, 0] = "eol";
                        
                        blokcodeArray[1, 0, 0] = "Begin";
                        blokcodeArray[1, 1, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";

                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 9:
                    {
                        //les introduceert blok eigenschappenscherm
                        globalHuidigLesNummer = 9;
                        globalBcArrayPosition = 0;
                        globalEsArrayPosition = 1;
                        vulBcBoxen();
                        eindeIsPlaced = true;
                        beginIsPlaced = true;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 9";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        infoPB.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;

                        infoTextBox.Text = "";
                        Font font = this.infoTextBox.SelectionFont;
                        FontStyle style;

                        style = FontStyle.Bold;
                        Font fontToApply = new Font(font, style);

                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionFont = fontToApply;
                        this.infoTextBox.SelectionColor = Color.Green;

                        infoTextBox.SelectedText = "Les 9: De eigenschappen van een actie blokje." + Environment.NewLine;

                        style = FontStyle.Regular;
                        fontToApply = new Font(font, style);
                        this.infoTextBox.SelectionColor = Color.Black;

                        infoTextBox.SelectedText = "Klik op de knop Lopen in vakje 2. Nu zie je de eigenschappen van het blokje Lopen in het eigenschappen scherm. Het actieblok Lopen heeft 3 eigenschappen, klik op het pijltje naar beneden van het eigenschappenscherm om de derde eigenschap te zien. Je kan elke WAARDE van een eigenschap veranderen door op de \"driehoek naar beneden\" naast de eigenschap te drukken. Verander nu de WAARDEN van eigenschap richting van het blokje Lopen in Links. Sleep nu de andere actieblokjes in het blokcodescherm. Bekijk ook de eigenschappen van deze blokjes en verander ze als jij dat wilt. Klik vervolgens op Bouw. Merk op dat Begin en Einde geen eigenschappen hebben !!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();
                        
                       
                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");

                        //vul bcArray

                        blokcodeArray[0, 0, 0] = "Begin";
                        blokcodeArray[0, 1, 0] = "eol";

                        blokcodeArray[1, 0, 0] = "Lopen";
                        blokcodeArray[1, 1, 0] = "links"; //richting links rechts rechtdoor (dropbox?)
                        blokcodeArray[1, 2, 0] = "2"; // sec?
                        blokcodeArray[1, 3, 0] = "100"; //100% power
                        blokcodeArray[1, 4, 0] = "eol";

                        blokcodeArray[5, 0, 0] = "Einde";
                        blokcodeArray[5, 1, 0] = "eol";

                        blokcodeArray[6, 0, 0] = "eof";
                    }
                    break;

                case 10:
                    {
                        //les introduceert sensor1 geluid met automatische alsdan
                        globalHuidigLesNummer = 10;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 9";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;
                        infoTextBox.Text = "Les 9: De eigenschappen van een actie blokje. Klik op de knop Lopen in vakje 2. Nu zie je de eigenschappen van het blokje Lopen in het eigenschappen scherm. Het actieblok Lopen heeft 3 eigenschappen, klik op het pijltje naar beneden van het eigenschappenscherm om de derde eigenschap te zien. Je kan elke WAARDE van een eigenschap veranderen door op de \"driehoek naar beneden\" naast de eigenschap te drukken. Verander nu de WAARDEN van eigenschap richting van het blokje Lopen in Links. Sleep nu de andere actieblokjes in het blokcodescherm. Bekijk ook de eigenschappen van deze blokjes en verander ze als jij dat wilt. Klik vervolgens op Bouw. Merk op dat Begin en Einde geen eigenschappen hebben !!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                        createNewDragButton("Geluid");
                    }
                    break;

                case 11:
                    {
                        //les introduceert sensor2 voelknop met automatische alsdan
                        globalHuidigLesNummer = 11;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 9";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;
                        infoTextBox.Text = "Les 9: De eigenschappen van een actie blokje. Klik op de knop Lopen in vakje 2. Nu zie je de eigenschappen van het blokje Lopen in het eigenschappen scherm. Het actieblok Lopen heeft 3 eigenschappen, klik op het pijltje naar beneden van het eigenschappenscherm om de derde eigenschap te zien. Je kan elke WAARDE van een eigenschap veranderen door op de \"driehoek naar beneden\" naast de eigenschap te drukken. Verander nu de WAARDEN van eigenschap richting van het blokje Lopen in Links. Sleep nu de andere actieblokjes in het blokcodescherm. Bekijk ook de eigenschappen van deze blokjes en verander ze als jij dat wilt. Klik vervolgens op Bouw. Merk op dat Begin en Einde geen eigenschappen hebben !!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                        createNewDragButton("Geluid");
                        createNewDragButton("Voelknop");
                    }
                    break;

                case 12:
                    {
                        //les introduceert sensor3 iets zien met automatische alsdan
                        globalHuidigLesNummer = 12;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 9";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;
                        infoTextBox.Text = "Les 9: De eigenschappen van een actie blokje. Klik op de knop Lopen in vakje 2. Nu zie je de eigenschappen van het blokje Lopen in het eigenschappen scherm. Het actieblok Lopen heeft 3 eigenschappen, klik op het pijltje naar beneden van het eigenschappenscherm om de derde eigenschap te zien. Je kan elke WAARDE van een eigenschap veranderen door op de \"driehoek naar beneden\" naast de eigenschap te drukken. Verander nu de WAARDEN van eigenschap richting van het blokje Lopen in Links. Sleep nu de andere actieblokjes in het blokcodescherm. Bekijk ook de eigenschappen van deze blokjes en verander ze als jij dat wilt. Klik vervolgens op Bouw. Merk op dat Begin en Einde geen eigenschappen hebben !!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                        createNewDragButton("Geluid");
                        createNewDragButton("Voelknop");
                        createNewDragButton("Iets zien");
                    }
                    break;

                case 13:
                    {
                        //les introduceert als..dan
                        globalHuidigLesNummer = 13;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 9";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox infoPB = new PictureBox();
                        infoPB.Name = "infoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        infoPB.Location = new Point(46, 261);
                        infoPB.Size = new Size(161, 111);
                        infoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_infoscherm_24bits;
                        this.Controls.Add(infoPB);
                        infoPB.BringToFront();
                        infoTextBox.Location = new Point(54, 270);
                        infoTextBox.Size = new Size(145, 100);
                        infoTextBox.Visible = true;
                        infoTextBox.Text = "Les 9: De eigenschappen van een actie blokje. Klik op de knop Lopen in vakje 2. Nu zie je de eigenschappen van het blokje Lopen in het eigenschappen scherm. Het actieblok Lopen heeft 3 eigenschappen, klik op het pijltje naar beneden van het eigenschappenscherm om de derde eigenschap te zien. Je kan elke WAARDE van een eigenschap veranderen door op de \"driehoek naar beneden\" naast de eigenschap te drukken. Verander nu de WAARDEN van eigenschap richting van het blokje Lopen in Links. Sleep nu de andere actieblokjes in het blokcodescherm. Bekijk ook de eigenschappen van deze blokjes en verander ze als jij dat wilt. Klik vervolgens op Bouw. Merk op dat Begin en Einde geen eigenschappen hebben !!";
                        infoTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Both;
                        infoTextBox.BringToFront();

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(96, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_1blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                        createNewDragButton("Geluid");
                        createNewDragButton("Voelknop");
                        createNewDragButton("Iets zien");
                        createNewDragButton("Als..Dan");
                    }
                    break;

                case 14:  //de functie werkt nog niet
                    {
                        //les introduceert 99 plaatsen ipv 20 
                        globalHuidigLesNummer = 14;

                        // initialize schermen
                        mainAchtergrond.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_achtergrond_niveauGevorderde_32bits;
                        mainAchtergrond.BringToFront(); //vanwege overwrite dragButtons als eerst op een ander niveau is geklikt; 
                        lesBox.Visible = true;
                        lesBox.BringToFront();
                        lesTextBox.Visible = true;
                        lesTextBox.Text = "Les 14";
                        lesTextBox.BringToFront();
                        volgendeLabel.BringToFront();
                        vorigeLabel.BringToFront();

                        PictureBox actiePB = new PictureBox();
                        actiePB.Name = "actiePB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        actiePB.Location = new Point(46, 106);
                        actiePB.Size = new Size(161, 144);
                        actiePB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_acties_4blok_24bits;
                        this.Controls.Add(actiePB);
                        actiePB.BringToFront();

                        PictureBox blokcodeschermPB = new PictureBox();
                        blokcodeschermPB.Name = "blokcodeschermPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        blokcodeschermPB.Location = new Point(217, 49);
                        blokcodeschermPB.Size = new Size(290, 496);
                        blokcodeschermPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_blokcodeschermMetScroll_24bits;
                        this.Controls.Add(blokcodeschermPB);
                        blokcodeschermPB.BringToFront();

                        PictureBox sensorPB = new PictureBox();
                        sensorPB.Name = "sensorPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        sensorPB.Location = new Point(46, 258);
                        sensorPB.Size = new Size(161, 119);
                        sensorPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_sensoren_3blok_24bits;
                        this.Controls.Add(sensorPB);
                        sensorPB.BringToFront();

                        PictureBox pseudoPB = new PictureBox();
                        pseudoPB.Name = "pseudoPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        pseudoPB.Location = new Point(517, 232);
                        pseudoPB.Size = new Size(277, 255);
                        pseudoPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_pseudo_24bits;
                        this.Controls.Add(pseudoPB);
                        pseudoPB.BringToFront();

                        PictureBox optiesPB = new PictureBox();
                        optiesPB.Name = "optiesPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        optiesPB.Location = new Point(45, 383);
                        optiesPB.Size = new Size(163, 99);
                        optiesPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_opties_2blok_24bits;
                        this.Controls.Add(optiesPB);
                        optiesPB.BringToFront();

                        PictureBox esPB = new PictureBox();
                        esPB.Name = "esPB" + globalNewPictureBoxTeller;
                        globalNewPictureBoxTeller++;
                        esPB.Location = new Point(517, 57);
                        esPB.Size = new Size(277, 166);
                        esPB.BackgroundImage = global::MaxdeRobot.Properties.Resources.MDR_ESscherm_24bits;
                        this.Controls.Add(esPB);
                        esPB.BringToFront();

                        lesVolgendeButton.BringToFront();
                        lesVorigeButton.BringToFront();
                        bcTellerBox1.BringToFront();
                        bcTellerBox2.BringToFront();
                        bcTellerBox3.BringToFront();
                        bcTellerBox4.BringToFront();
                        bcTellerBox5.BringToFront();
                        bcTellerBox6.BringToFront();

                        regel1DeleteButton.BringToFront();
                        regel2DeleteButton.BringToFront();
                        regel3DeleteButton.BringToFront();
                        regel4DeleteButton.BringToFront();
                        regel5DeleteButton.BringToFront();
                        regel6DeleteButton.BringToFront();

                        regel1UpButton.BringToFront();
                        regel2UpButton.BringToFront();
                        regel3UpButton.BringToFront();
                        regel4UpButton.BringToFront();
                        regel5UpButton.BringToFront();
                        regel6UpButton.BringToFront();

                        regel1DownButton.BringToFront();
                        regel2DownButton.BringToFront();
                        regel3DownButton.BringToFront();
                        regel4DownButton.BringToFront();
                        regel5DownButton.BringToFront();
                        regel6DownButton.BringToFront();

                        esPlaatje.BringToFront();
                        esUpButton.BringToFront();
                        esDownButton.BringToFront();
                        esDropWaardeBox1.BringToFront();
                        esDropWaardeBox2.BringToFront();
                        esBox1.BringToFront();
                        esBox2.BringToFront();

                        bcUpButton.BringToFront();
                        bcDownButton.BringToFront();

                        pseudoBox.BringToFront();

                        bouwButton.BringToFront();

                        //initialize buttons
                        bcUpButton.Visible = true;
                        bcDownButton.Visible = true;

                        regel1DeleteButton.Visible = true;
                        regel2DeleteButton.Visible = true;
                        regel3DeleteButton.Visible = true;
                        regel4DeleteButton.Visible = true;
                        regel5DeleteButton.Visible = true;
                        regel6DeleteButton.Visible = true;

                        regel1UpButton.Visible = true;
                        regel2UpButton.Visible = true;
                        regel3UpButton.Visible = true;
                        regel4UpButton.Visible = true;
                        regel5UpButton.Visible = true;
                        regel6UpButton.Visible = true;

                        regel1DownButton.Visible = true;
                        regel2DownButton.Visible = true;
                        regel3DownButton.Visible = true;
                        regel4DownButton.Visible = true;
                        regel5DownButton.Visible = true;
                        regel6DownButton.Visible = true;

                        bcTellerBox1.Visible = true;
                        bcTellerBox2.Visible = true;
                        bcTellerBox3.Visible = true;
                        bcTellerBox4.Visible = true;
                        bcTellerBox5.Visible = true;
                        bcTellerBox6.Visible = true;

                        esPlaatje.Visible = true;
                        esDropWaardeBox1.Visible = true;
                        esDropWaardeBox2.Visible = true;
                        esUpButton.Visible = true;
                        esDownButton.Visible = true;
                        esBox1.Visible = true;
                        esBox2.Visible = true;

                        pseudoBox.Visible = true;
                        bouwButton.Visible = true;

                        //initialize dragbuttons
                        createNewDragButton("Lopen");
                        createNewDragButton("Praten");
                        createNewDragButton("Arm/Hoofd");
                        createNewDragButton("Tekening");
                        createNewDragButton("Begin");
                        createNewDragButton("Einde");
                        createNewDragButton("Geluid");
                        createNewDragButton("Voelknop");
                        createNewDragButton("Iets zien");
                        createNewDragButton("Als..Dan");
                    }
                    break;

                default:
                    {
                    }
                    break;
            }
            vulBcBoxen();
        }

        #endregion







        #endregion



        #region alle Filters [WARNING filters will be removed soon]
        private string filterActieWaarde(int arrayRij)
        {
            //Doel: positie voor arrayRij komt binnen. parst uit voorbeelregel  "ifelseJa(Leeg),Leeg(Leeg);" de actie Leeg na de komma of in "ifelseNee(Geluid > 50)" + ",Lopen(links,10,100)"; de actie Lopen
            // zoek 1: ga naar , voor tweede gedeelte van string. 
            // zoek 2: zoek eerste ( zodat de teller weet dat de gezochte waarde tussen , en (  zit.
            // vul de hulp string met de gezochte waarde;

            string deel1array;
            string deel2array;
            bool commaNotFound = true;
            bool braceNotFound = true;
            int beginteller = -1;
            int eindeteller = 0;
            char hulp;


            deel1array = blokcodeArray[arrayRij, 1, 0];

            //zoek deel1
            while (commaNotFound == true)
            {
                beginteller++;
                hulp = deel1array[beginteller];
                if (hulp == ',')
                    commaNotFound = false;
            }

            eindeteller = beginteller;

            //zoek deel2

            while (braceNotFound == true)
            {
                eindeteller++;
                hulp = deel1array[eindeteller];
                if (hulp == '(')
                    braceNotFound = false;
            }

            deel2array = deel1array[beginteller + 1].ToString(); //initialiseer eerste waarde;
            //vul mbv beginteller en eindeteller actiewoord waarde in return waarde
            for (int i = beginteller + 2; i < (eindeteller); i++)
            {
                deel2array += deel1array[i];
            }
            //pseudoBox.SelectedText = "beginpos: " + beginteller;
            // pseudoBox.SelectedText = "eindpos: " + eindeteller;
            // pseudoBox.SelectedText = deel2array;
            return (deel2array);
        } //WARNING this method is to be removed soon  ALL

        private string filterActieEnWaarden(int arrayRij, string soortButton)
        {
            //   blokcodeArray[arrayRij, 1] = "ifelseJa(Geluid > 50)" + ",leeg";  // ifelseJa(soundValue > someValue),lopen(x,y,z);      50 dB
            string helearray;
            string deel1array;
            string deel2array;
            bool commaNotFound = true;
            bool braceNotFound = true;
            int beginteller = -1;
            int eindeteller = 0;
            int teller1 = 0;
            char hulp;

            helearray = blokcodeArray[arrayRij, 1, 0];

            //zoek  begin deel 2
            while (commaNotFound == true)
            {
                beginteller++;
                hulp = helearray[beginteller];
                if (hulp == ',')
                    commaNotFound = false;
            }

            eindeteller = beginteller;

            //zoek einde actiewoord 
            while (braceNotFound == true)
            {
                eindeteller++;
                hulp = helearray[eindeteller];
                if (hulp == ')')
                    braceNotFound = false;
            }

            deel1array = "ifelse"; // filtert alles tussen ifelse en de actiewaarde naar deel1array zodat deel1 compleet is.
            for (int i = 6; i < beginteller; i++)
            {
                deel1array += helearray[i];
            }


            deel2array = ","; //filtert alles tussen deel1 tot einde van de regel incl. ;)

            switch (soortButton)
            {
                case ("Lopen"):
                    {
                        deel2array += "Lopen(links,10,100);";
                    }
                    break;

                case ("Praten"):
                    {
                        deel2array += "Praten(Hello,1);";
                    }
                    break;

                case ("Arm/Hoofd"):
                    {
                        deel2array += "Arm/Hoofd(10,100);";
                    }
                    break;

                case ("Tekening"):
                    {
                        deel2array += "Tekening(Hartje,10);";
                    }
                    break;

                default:
                    {
                    }
                    break;
            }



            deel1array += deel2array; //deel 1 en 2 samenvoegen 
            return (deel1array);
        } //WARNING this method is to be removed soon  ALL

        private string filterJaNee(int arrayRij)
        {
            string helearray;

            helearray = blokcodeArray[arrayRij, 1, 0];

            //pseudoBox.SelectedText = helearray;
            if (helearray == "")
            {
                return ("Leeg");
            }
            else
            {
                if (helearray.Length < 6)
                {
                    return ("Geen JaNee");
                }
                else
                {

                    if (helearray[6] == 'J')
                    {
                        return ("Ja");
                    }
                    else
                    {
                        return ("Nee");
                    }
                }
            }
        } //WARNING this method is to be removed soon  ALL

        private string filterSensorWaarde(int arrayRij)
        {
            //Doel: positie voor arrayRij komt binnen. parst uit voorbeelregel  "ifelseJa(Leeg),Leeg(Leeg);" de sensor Leeg voor de komma of in "ifelseNee(Geluid > 50)" + ",Lopen(links,10,100)"; de sensor Geluid
            // zoek 1: ga naar ( voor eerste gedeelte van string. 
            // de eerste char na de ( indicieert of een sensoor of leeg );

            string helearray;
            string deel2array;
            bool braceNotFound = true;
            int beginteller = -1;
            char hulp;

            helearray = blokcodeArray[arrayRij, 1, 0];

            //zoek 1
            while (braceNotFound == true)
            {
                beginteller++;
                hulp = helearray[beginteller];
                if (hulp == '(')
                    braceNotFound = false;
            }

            hulp = helearray[beginteller + 1];
            //pseudoBox.SelectedText = hulp.ToString();

            switch (hulp)
            {
                case ('G'):
                    {
                        deel2array = "Geluid";
                    }
                    break;

                case ('V'):
                    {
                        deel2array = "Voelknop";
                    }
                    break;

                case ('I'):
                    {
                        deel2array = "Iets zien";
                    }
                    break;

                default:
                    {
                        deel2array = "Leeg";
                    }
                    break;
            }

            //   pseudoBox.SelectedText = deel2array;
            return (deel2array);

        } //WARNING this method is to be removed soon  ALL

        private string[] filterSensorParameters(string str)
        {
            // debuggerBox.Text = "ifelseJa(Geluid > 50),Leeg(Leeg);" + Environment.NewLine;
            // ifelseJa(Geluid > 50),Leeg(Leeg);
            string[] parameters = new string[1];
            string parameter, sensorEnWaarde;

            int beginOfActionWord = str.IndexOf('(');
            int endOfActionWord = str.IndexOf(')');
            // debuggerBox.Text += "( = " + beginOfActionWord + ", ) = " + endOfActionWord + Environment.NewLine;

            sensorEnWaarde = str.Substring(beginOfActionWord + 1, endOfActionWord - (beginOfActionWord + 1));

            //    debuggerBox.Text += "inhoud: " + sensorEnWaarde + Environment.NewLine;

            string[] segments = sensorEnWaarde.Split(' ');

            if (segments.Length == 1)
                return parameters;

            parameter = segments[segments.Length - 1].Trim();

            //   debuggerBox.Text += " waarde: " + parameter + Environment.NewLine;

            parameters[0] = parameter;

            return parameters;
        }

        private void lesTextBox_TextChanged(object sender, EventArgs e)
        {

        }

        private void esBox1_TextChanged(object sender, EventArgs e)
        {

        }

   
        
     

         //WARNING this method is to be removed soon  ALL

        #endregion
    }
}